package physapps.linearoscillations;

import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class DrivenBeamOscillator extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new DrivenBeamOscillator(), 525, 485);
  }

  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    drivenSpring1 = new physbeans.phys.DrivenSpring();
    drivenBeamView1 = new physbeans.views.DrivenBeamView();
    multiplexer1 = new physbeans.func.Multiplexer();
    parsedFunction1 = new physbeans.func.ParsedFunction();
    gainFunction1 = new physbeans.func.GainFunction();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSliderX0 = new physbeans.inout.TextSlider();
    textSliderH = new physbeans.inout.TextSlider();
    textSliderL = new physbeans.inout.TextSlider();
    textSliderMu = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    drivenSpring1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        drivenSpring1ValueChanged(evt);
        drivenSpring1ValueChanged1(evt);
      }
    });

    drivenBeamView1.setBeamHeight(0.13);
    drivenBeamView1.setBeamLength(1.3);
    drivenBeamView1.setWheelRadius(0.1);
    drivenBeamView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        drivenBeamView1SourceChanged(evt);
      }
    });

    multiplexer1.setCollectInput(false);
    multiplexer1.setInputLength(3);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });

    parsedFunction1.setFunction(new String[] {"(2*mu*g)/(l - mu*h)"});
    parsedFunction1.setParameter(DVector.valueOf("[9.81]"));
    parsedFunction1.setVariableName(new String[] {"h", "l", "mu", "g"});
    parsedFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedFunction1ValueChanged(evt);
      }
    });

    gainFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        gainFunction1ValueChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    layeredScreen1.setBackground(java.awt.Color.white);
    layeredScreen1.setBordered(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxY(1.5);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1);

    oscilloscope1.setMaxY(0.6);
    oscilloscope1.setMinY(-0.6);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.linearoscillations.DrivenBeamOscillator", currentLocale); // NOI18N
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    outputPanel1.add(oscilloscope1);

    jPanel2.add(outputPanel1);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(25L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.setTimeIncrement(0.05);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
        timer1NextStep1(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
      }
    });
    inputPanel1.add(timer1);

    textSliderX0.setDescription(bundle.getString("x0")); // NOI18N
    textSliderX0.setModel(new BoundedRealModel(-1.0,0.3,1.0));
    textSliderX0.setPrecision(3);
    textSliderX0.setUnit("m");
    textSliderX0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderX0PropertyChange(evt);
      }
    });
    inputPanel1.add(textSliderX0);

    textSliderH.setDescription("h =");
    textSliderH.setModel(new BoundedRealModel(0.0,0.15,1.0));
    textSliderH.setUnit("m");
    textSliderH.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderHPropertyChange(evt);
      }
    });
    inputPanel1.add(textSliderH);

    textSliderL.setDescription("l =");
    textSliderL.setModel(new BoundedRealModel(0.2,0.5,1.0));
    textSliderL.setUnit("m");
    textSliderL.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderLPropertyChange(evt);
      }
    });
    inputPanel1.add(textSliderL);

    textSliderMu.setDescription(bundle.getString("mu")); // NOI18N
    textSliderMu.setModel(new BoundedRealModel(0.0,0.5,2.0));
    textSliderMu.setPrecision(3);
    textSliderMu.setUnit("");
    textSliderMu.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderMuPropertyChange(evt);
      }
    });
    inputPanel1.add(textSliderMu);

    switchBox1.setBoxLabel(new String[] {
      bundle.getString("s1"),
      bundle.getString("s2")
    });
    switchBox1.setTitle(bundle.getString("s3")); // NOI18N
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    inputPanel1.add(switchBox1);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void drivenSpring1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_drivenSpring1ValueChanged1
    drivenBeamView1.setBeamDisplacement(drivenSpring1.getOutputVector().x());
  }//GEN-LAST:event_drivenSpring1ValueChanged1

  private void drivenSpring1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_drivenSpring1ValueChanged
    oscilloscope1.setInputVector(drivenSpring1.getOutputVector());
  }//GEN-LAST:event_drivenSpring1ValueChanged

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged

  private void textSliderMuPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderMuPropertyChange
    multiplexer1.setInputValues(2, textSliderMu.getValue());
  }//GEN-LAST:event_textSliderMuPropertyChange

  private void textSliderX0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderX0PropertyChange
    double val = textSliderX0.getValue();
    drivenSpring1.setX0(val);
    drivenBeamView1.setInitialValue(0, val);
  }//GEN-LAST:event_textSliderX0PropertyChange

  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart1

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    drivenSpring1.restart();
    drivenBeamView1.restart();
  }//GEN-LAST:event_timer1Restart

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    drivenSpring1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep

  private void drivenBeamView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_drivenBeamView1SourceChanged
    layeredScreen1.addView(drivenBeamView1);
  }//GEN-LAST:event_drivenBeamView1SourceChanged

  private void timer1NextStep1(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep1
    gainFunction1.setInputValue(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep1

  private void gainFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_gainFunction1ValueChanged
    drivenBeamView1.setWheelAngle(gainFunction1.getOutputValue());
  }//GEN-LAST:event_gainFunction1ValueChanged

  private void textSliderHPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderHPropertyChange
    drivenBeamView1.setBeamHeight(textSliderH.getValue());
    multiplexer1.setInputValues(0, textSliderH.getValue());
  }//GEN-LAST:event_textSliderHPropertyChange

  private void textSliderLPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderLPropertyChange
    drivenBeamView1.setWheelDistance(textSliderL.getValue());
    multiplexer1.setInputValues(1, textSliderL.getValue());
  }//GEN-LAST:event_textSliderLPropertyChange

  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    parsedFunction1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged

  private void parsedFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedFunction1ValueChanged
    drivenSpring1.setC(parsedFunction1.getOutputValue());
  }//GEN-LAST:event_parsedFunction1ValueChanged

  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.DrivenBeamView drivenBeamView1;
  protected physbeans.phys.DrivenSpring drivenSpring1;
  protected physbeans.func.GainFunction gainFunction1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.func.ParsedFunction parsedFunction1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSliderH;
  protected physbeans.inout.TextSlider textSliderL;
  protected physbeans.inout.TextSlider textSliderMu;
  protected physbeans.inout.TextSlider textSliderX0;
  protected physbeans.inout.Timer timer1;
  // End of variables declaration//GEN-END:variables
}
