package physapps.linearoscillations;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class EnergySpring extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new EnergySpring(), 540, 525);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    drivenSpring1 = new physbeans.phys.DrivenSpring();
    parsedFunction1 = new physbeans.func.ParsedFunction();
    springView1 = new physbeans.views.SpringView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    drivenSpring1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        drivenSpring1ValueChanged(evt);
      }
    });

    parsedFunction1.setFunction(new String[] {"0.5*m*v*v", "0.5*c*x*x", "m*g*x", "0.5*m*v*v + 0.5*c*x*x + m*g*x"});
    parsedFunction1.setParameter(DVector.valueOf("[1.0,9.81,1.0]"));
    parsedFunction1.setVariableName(new String[] {"x", "v", "c", "g", "m"});
    parsedFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedFunction1ValueChanged(evt);
      }
    });

    springView1.setEndLineLength(0.7);
    springView1.setFixPosition(3.0);
    springView1.setMassHeight(0.15);
    springView1.setMassWidth(0.9);
    springView1.setSpringWidth(0.3);
    springView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        springView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    layeredScreen1.setBackground(java.awt.Color.white);
    layeredScreen1.setBordered(true);
    layeredScreen1.setMaxY(3.0);
    layeredScreen1.setMinY(-6.0);
    layeredScreen1.setOpaque(true);
    layeredScreen1.setXyExchanged(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1);

    oscilloscope1.setNLines(4);
    oscilloscope1.setLineActive(new boolean[]{true,true,false,false});
    oscilloscope1.setMaxY(22.0);
    oscilloscope1.setMinY(-22.0);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.linearoscillations.EnergySpring", currentLocale); // NOI18N
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    outputPanel1.add(oscilloscope1);

    jPanel2.add(outputPanel1);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(15L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel1.add(timer1);

    textSlider1.setDescription("x(0) =");
    textSlider1.setModel(new BoundedRealModel(-2.0,-2.0,2.0));
    textSlider1.setUnit("m");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider1);

    textSlider2.setDescription("v(0) =");
    textSlider2.setModel(new BoundedRealModel(-2.0,2.0,2.0));
    textSlider2.setUnit("m/s");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider2);

    textSlider3.setDescription("b/m =");
    textSlider3.setModel(new BoundedRealModel(0.0,0.0,2.0));
    textSlider3.setUnit("1/s");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider3);

    textSlider4.setDescription("c/m =");
    textSlider4.setLogarithmic(true);
    textSlider4.setModel(new BoundedRealModel(1.0,3.0,100.0));
    textSlider4.setUnit("1/s\u00b2");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider4);

    textSlider5.setDescription("g =");
    textSlider5.setModel(new BoundedRealModel(0.0,0.0,19.62));
    textSlider5.setUnit("m/s\u00b2");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider5);

    switchBox1.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.EnergySpring", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.EnergySpring", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.EnergySpring", currentLocale).getString("s3"),
      java.util.ResourceBundle.getBundle("physapps.linearoscillations.EnergySpring", currentLocale).getString("s4")
    }
  );
  switchBox1.setSelected(new boolean[]{true,true,false,false});
  switchBox1.setTitle(bundle.getString("s5")); // NOI18N
  switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      switchBox1ValueChanged(evt);
    }
  });
  inputPanel1.add(switchBox1);

  jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

  getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void springView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_springView1SourceChanged
    layeredScreen1.addView(springView1);
  }//GEN-LAST:event_springView1SourceChanged

  private void parsedFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedFunction1ValueChanged
    oscilloscope1.setInputVector(parsedFunction1.getOutputVector());
  }//GEN-LAST:event_parsedFunction1ValueChanged

  private void drivenSpring1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_drivenSpring1ValueChanged
    DVector val = drivenSpring1.getOutputVector();
    springView1.setModel(val);
    parsedFunction1.setInputVector(val);
  }//GEN-LAST:event_drivenSpring1ValueChanged
        
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    double d = textSlider5.getValue();
    parsedFunction1.setParameter(1, d);
    drivenSpring1.setG(d);
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double d = textSlider4.getValue();
    parsedFunction1.setParameter(0, d);
    drivenSpring1.setC(d);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    drivenSpring1.setB(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    springView1.setInitialValue(0, textSlider1.getValue());
    drivenSpring1.setX0(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    drivenSpring1.setV0(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    drivenSpring1.restart();
    oscilloscope1.restart();
    springView1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    drivenSpring1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.DrivenSpring drivenSpring1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.func.ParsedFunction parsedFunction1;
  protected physbeans.views.SpringView springView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.Timer timer1;
  // End of variables declaration//GEN-END:variables
  
}
