package physapps.linearoscillations;

import physbeans.inout.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class InitialValueChain2 extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new InitialValueChain2(), 580, 580);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    linearChainOscillator1 = new physbeans.phys.LinearChainOscillator();
    springChainView1 = new physbeans.views.SpringChainView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    vectorSliderX0 = new physbeans.inout.VectorSlider();
    vectorSliderV0 = new physbeans.inout.VectorSlider();
    vectorSliderM = new physbeans.inout.VectorSlider();
    vectorSliderC = new physbeans.inout.VectorSlider();
    vectorSliderB = new physbeans.inout.VectorSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    linearChainOscillator1.setDamperCoefficients(DVector.valueOf("[0.0,0.0,0.0]"));
    linearChainOscillator1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        linearChainOscillator1ValueChanged1(evt);
        linearChainOscillator1ValueChanged(evt);
      }
    });

    springChainView1.setXScale(0.15);
    springChainView1.setBasementWidth(0.0);
    springChainView1.setHideHugeSprings(true);
    springChainView1.setMassScale(0.6);
    springChainView1.setSpringScale(0.8);
    springChainView1.setSystem(linearChainOscillator1);
    springChainView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        springChainView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setLayout(new java.awt.BorderLayout());

    layeredScreen1.setBackground(new java.awt.Color(255, 255, 255));
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(3.0);
    layeredScreen1.setMinX(0.0);
    layeredScreen1.setOpaque(true);
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setPreferredSize(new java.awt.Dimension(300, 142));
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.LINE_AXIS));

    oscilloscope1.setLineActive(new boolean[] {true, true});
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.linearoscillations.InitialValueChain2", currentLocale); // NOI18N
    oscilloscope1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    oscilloscope1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    outputPanel.add(oscilloscope1);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(20L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
        timer1Restart2(evt);
      }
    });
    inputPanel.add(timer1);

    vectorSliderX0.setCount(2);
    vectorSliderX0.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
    vectorSliderX0.setDescription("x0 =");
    vectorSliderX0.setInitialValues(DVector.valueOf("[1.0,0.0]"));
    vectorSliderX0.setMinimum(-1.0);
    vectorSliderX0.setUnit("m");
    vectorSliderX0.setVertical(false);
    vectorSliderX0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderX0PropertyChange(evt);
        vectorSliderX0PropertyChange1(evt);
      }
    });
    inputPanel.add(vectorSliderX0);

    vectorSliderV0.setCount(2);
    vectorSliderV0.setDescription("v0 =");
    vectorSliderV0.setMinimum(-1.0);
    vectorSliderV0.setUnit("m/s");
    vectorSliderV0.setVertical(false);
    vectorSliderV0.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderV0PropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderV0);

    vectorSliderM.setCount(2);
    vectorSliderM.setDescription("m =");
    vectorSliderM.setInitialValues(DVector.valueOf("[1.0,1.0]"));
    vectorSliderM.setMaximum(5.0);
    vectorSliderM.setMinimum(1.0E-4);
    vectorSliderM.setUnit("kg");
    vectorSliderM.setVertical(false);
    vectorSliderM.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderMPropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderM);

    vectorSliderC.setCount(3);
    vectorSliderC.setDescription("c =");
    vectorSliderC.setInitialValues(DVector.valueOf("[1.0,1.0,1.0]"));
    vectorSliderC.setMaximum(5.0);
    vectorSliderC.setUnit("N/m");
    vectorSliderC.setVertical(false);
    vectorSliderC.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderCPropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderC);

    vectorSliderB.setCount(3);
    vectorSliderB.setDescription("b =");
    vectorSliderB.setMaximum(5.0);
    vectorSliderB.setUnit("Ns/m");
    vectorSliderB.setVertical(false);
    vectorSliderB.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSliderBPropertyChange(evt);
      }
    });
    inputPanel.add(vectorSliderB);

    switchBox1.setBoxLabel(new String[] {"x1", "x2"});
    switchBox1.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
    switchBox1.setSelected(new boolean[] {true, true});
    switchBox1.setTitle(bundle.getString("s1")); // NOI18N
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    inputPanel.add(switchBox1);

    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void linearChainOscillator1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged
    oscilloscope1.setInputVector(linearChainOscillator1.getDisplacements());
  }//GEN-LAST:event_linearChainOscillator1ValueChanged

  private void linearChainOscillator1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_linearChainOscillator1ValueChanged1
    springChainView1.setDisplacements(linearChainOscillator1.getDisplacements());
  }//GEN-LAST:event_linearChainOscillator1ValueChanged1

  private void vectorSliderMPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderMPropertyChange
    linearChainOscillator1.setMasses(vectorSliderM.getValue());
  }//GEN-LAST:event_vectorSliderMPropertyChange

  private void vectorSliderV0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderV0PropertyChange
    linearChainOscillator1.setV0(vectorSliderV0.getValue());
  }//GEN-LAST:event_vectorSliderV0PropertyChange

  private void vectorSliderX0PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderX0PropertyChange1
    springChainView1.setInitialDisplacements(vectorSliderX0.getValue());
  }//GEN-LAST:event_vectorSliderX0PropertyChange1

  private void vectorSliderX0PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderX0PropertyChange
    linearChainOscillator1.setX0(vectorSliderX0.getValue());
  }//GEN-LAST:event_vectorSliderX0PropertyChange

  private void vectorSliderCPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderCPropertyChange
    linearChainOscillator1.setSpringStiffnesses(vectorSliderC.getValue());
  }//GEN-LAST:event_vectorSliderCPropertyChange

  private void timer1Restart2(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart2
    springChainView1.restart();
  }//GEN-LAST:event_timer1Restart2

  private void springChainView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_springChainView1SourceChanged
    layeredScreen1.addView(springChainView1);
  }//GEN-LAST:event_springChainView1SourceChanged

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged

  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    linearChainOscillator1.restart();
  }//GEN-LAST:event_timer1Restart1

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    linearChainOscillator1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep

  private void vectorSliderBPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSliderBPropertyChange
    linearChainOscillator1.setDamperCoefficients(vectorSliderB.getValue());
  }//GEN-LAST:event_vectorSliderBPropertyChange
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.LinearChainOscillator linearChainOscillator1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.views.SpringChainView springChainView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.VectorSlider vectorSliderB;
  protected physbeans.inout.VectorSlider vectorSliderC;
  protected physbeans.inout.VectorSlider vectorSliderM;
  protected physbeans.inout.VectorSlider vectorSliderV0;
  protected physbeans.inout.VectorSlider vectorSliderX0;
  // End of variables declaration//GEN-END:variables
  
}
