package physapps.mathematics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class Interpolation extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new Interpolation(), 600, 420);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    strideVector1 = new physbeans.func.StrideVector();
    pointView1 = new physbeans.views.PointView();
    strideVector2 = new physbeans.func.StrideVector();
    interpolation1DFunction1 = new physbeans.func.Interpolation1DFunction();
    interpolation1DFunction2 = new physbeans.func.Interpolation1DFunction();
    interpolation1DFunction3 = new physbeans.func.Interpolation1DFunction();
    functionView1 = new physbeans.views.FunctionView();
    functionView2 = new physbeans.views.FunctionView();
    functionView3 = new physbeans.views.FunctionView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    controlledLayeredScreen1 = new physbeans.inout.ControlledLayeredScreen();
    inputPanel = new physbeans.inout.PhysicsPanel();
    vectorSlider1 = new physbeans.inout.VectorSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    strideVector1.setOutputSize(11);
    strideVector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        strideVector1ValueChanged(evt);
        strideVector1ValueChanged1(evt);
      }
    });

    pointView1.setPointColor(new java.awt.Color(0, 0, 0));
    pointView1.setPointRadius(0.1);
    pointView1.setUseTwoVectors(true);
    pointView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointView1SourceChanged(evt);
      }
    });

    strideVector2.setOutputSize(300);
    strideVector2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        strideVector2ValueChanged(evt);
        strideVector2ValueChanged1(evt);
      }
    });

    interpolation1DFunction1.setInterpolatorType(0);

    interpolation1DFunction2.setInterpolatorType(1);

    functionView1.setLineColor(new java.awt.Color(31, 31, 215));
    functionView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView1SourceChanged(evt);
      }
    });

    functionView2.setLineColor(new java.awt.Color(36, 185, 36));
    functionView2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView2SourceChanged(evt);
      }
    });

    functionView3.setLineColor(new java.awt.Color(217, 55, 55));
    functionView3.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView3SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBordered(true);
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setLayout(new java.awt.BorderLayout());

    controlledLayeredScreen1.setBordered(true);
    controlledLayeredScreen1.setMaxX(10.0);
    controlledLayeredScreen1.setMaxY(12.0);
    controlledLayeredScreen1.setMinX(0.0);
    controlledLayeredScreen1.setMinY(-12.0);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.mathematics.Interpolation", currentLocale); // NOI18N
    controlledLayeredScreen1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    controlledLayeredScreen1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    controlledLayeredScreen1.setViewActive(new boolean[]{true,false,false,true});
    objectPanel.add(controlledLayeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    vectorSlider1.setCount(11);
    vectorSlider1.setDescription("yi =");
    vectorSlider1.setInitialValues(DVector.valueOf("[0.0,0.0,0.0,0.0,0.0,2.0,0.0,0.0,0.0,0.0,0.0]"));
    vectorSlider1.setMaximum(10.0);
    vectorSlider1.setMinimum(-10.0);
    vectorSlider1.setUnit("");
    vectorSlider1.setVertical(false);
    vectorSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        vectorSlider1PropertyChange(evt);
        vectorSlider1PropertyChange1(evt);
        vectorSlider1PropertyChange2(evt);
      }
    });
    inputPanel.add(vectorSlider1);

    switchBox1.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.mathematics.Interpolation", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.mathematics.Interpolation", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.mathematics.Interpolation", currentLocale).getString("s3"),
      java.util.ResourceBundle.getBundle("physapps.mathematics.Interpolation", currentLocale).getString("s4")
    });
    switchBox1.setSelected(new boolean[]{true,false,false,true});
    switchBox1.setTitle(bundle.getString("diagramTitle")); // NOI18N
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    inputPanel.add(switchBox1);

    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    controlledLayeredScreen1.setViewActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void functionView3SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView3SourceChanged
    controlledLayeredScreen1.addView(functionView3);
  }//GEN-LAST:event_functionView3SourceChanged
  
  private void functionView2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView2SourceChanged
    controlledLayeredScreen1.addView(functionView2);
  }//GEN-LAST:event_functionView2SourceChanged
      
  private void strideVector1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_strideVector1ValueChanged1
    interpolation1DFunction1.setDataX(strideVector1.getOutputVector());
    interpolation1DFunction2.setDataX(strideVector1.getOutputVector());
    interpolation1DFunction3.setDataX(strideVector1.getOutputVector());
  }//GEN-LAST:event_strideVector1ValueChanged1
  
  private void vectorSlider1PropertyChange2(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSlider1PropertyChange2
    interpolation1DFunction1.setDataY(vectorSlider1.getValue());
    interpolation1DFunction2.setDataY(vectorSlider1.getValue());
    interpolation1DFunction3.setDataY(vectorSlider1.getValue());
  }//GEN-LAST:event_vectorSlider1PropertyChange2
  
  private void functionView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView1SourceChanged
    controlledLayeredScreen1.addView(functionView1);
  }//GEN-LAST:event_functionView1SourceChanged
  
  private void vectorSlider1PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSlider1PropertyChange1
    strideVector2.trigger();
  }//GEN-LAST:event_vectorSlider1PropertyChange1
  
  private void strideVector2ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_strideVector2ValueChanged1
    functionView1.setModel(strideVector2.getOutputVector(), interpolation1DFunction1.getOutputVector());
    functionView2.setModel(strideVector2.getOutputVector(), interpolation1DFunction2.getOutputVector());
    functionView3.setModel(strideVector2.getOutputVector(), interpolation1DFunction3.getOutputVector());
  }//GEN-LAST:event_strideVector2ValueChanged1
  
  private void strideVector2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_strideVector2ValueChanged
    interpolation1DFunction1.setInputVector(strideVector2.getOutputVector());
    interpolation1DFunction2.setInputVector(strideVector2.getOutputVector());
    interpolation1DFunction3.setInputVector(strideVector2.getOutputVector());
  }//GEN-LAST:event_strideVector2ValueChanged
  
  private void vectorSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_vectorSlider1PropertyChange
    strideVector1.trigger();
  }//GEN-LAST:event_vectorSlider1PropertyChange
  
  private void pointView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointView1SourceChanged
    controlledLayeredScreen1.addView(pointView1);
  }//GEN-LAST:event_pointView1SourceChanged
  
  private void strideVector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_strideVector1ValueChanged
    pointView1.setModel(strideVector1.getOutputVector(), vectorSlider1.getValue());
  }//GEN-LAST:event_strideVector1ValueChanged
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.ControlledLayeredScreen controlledLayeredScreen1;
  protected physbeans.views.FunctionView functionView1;
  protected physbeans.views.FunctionView functionView2;
  protected physbeans.views.FunctionView functionView3;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected physbeans.func.Interpolation1DFunction interpolation1DFunction1;
  protected physbeans.func.Interpolation1DFunction interpolation1DFunction2;
  protected physbeans.func.Interpolation1DFunction interpolation1DFunction3;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.views.PointView pointView1;
  protected physbeans.func.StrideVector strideVector1;
  protected physbeans.func.StrideVector strideVector2;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.VectorSlider vectorSlider1;
  // End of variables declaration//GEN-END:variables
  
}
