package physapps.mathematics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;

/**
 * base class of all simple computation applets <br>
 * contains an input and an output panel<br>
 *
 */
public class PolyRoot extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new PolyRoot(), 350, 300);
  }
  
  protected Polynomial poly;
  protected int prec = 4;
  
  /** Creates new form PhysicsApplet */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    
    jPanel1 = new javax.swing.JPanel();
    inputPanel1 = new physbeans.inout.InputPanel();
    message2 = new physbeans.inout.Message();
    inputPanel2 = new physbeans.inout.InputPanel();
    jButton1 = new javax.swing.JButton();
    jCheckBox1 = new javax.swing.JCheckBox();
    outputPanel1 = new physbeans.inout.OutputPanel();
    message1 = new physbeans.inout.Message();
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED), new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    
    message2.setDescription(java.util.ResourceBundle.getBundle("physapps.mathematics.PolyRoot", currentLocale).getString("s1"));
    message2.setEditable(true);
    inputPanel1.add(message2);
    
    inputPanel2.setLayout(new java.awt.FlowLayout());
    
    jButton1.setBackground(null);
    jButton1.setFont(null);
    jButton1.setText(java.util.ResourceBundle.getBundle("physapps.mathematics.PolyRoot", currentLocale).getString("s5"));
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButton1ActionPerformed(evt);
      }
    });
    
    inputPanel2.add(jButton1);
    
    jCheckBox1.setBackground(null);
    jCheckBox1.setFont(null);
    jCheckBox1.setText(java.util.ResourceBundle.getBundle("physapps.mathematics.PolyRoot", currentLocale).getString("s6"));
    jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jCheckBox1ActionPerformed(evt);
      }
    });
    
    inputPanel2.add(jCheckBox1);
    
    inputPanel1.add(inputPanel2);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.NORTH);
    
    outputPanel1.setLayout(new javax.swing.BoxLayout(outputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    
    message1.setDescription(java.util.ResourceBundle.getBundle("physapps.mathematics.PolyRoot", currentLocale).getString("s3"));
    outputPanel1.add(message1);
    
    jPanel1.add(outputPanel1, java.awt.BorderLayout.CENTER);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }
// </editor-fold>//GEN-END:initComponents
  
  private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
    if (jCheckBox1.isSelected()) {
      prec = 12;
    } else {
      prec = 4;
    }
  }//GEN-LAST:event_jCheckBox1ActionPerformed
  
  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    compute();
  }//GEN-LAST:event_jButton1ActionPerformed
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.InputPanel inputPanel1;
  protected physbeans.inout.InputPanel inputPanel2;
  protected javax.swing.JButton jButton1;
  protected javax.swing.JCheckBox jCheckBox1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.Message message1;
  protected physbeans.inout.Message message2;
  protected physbeans.inout.OutputPanel outputPanel1;
// End of variables declaration//GEN-END:variables
  
  protected void compute() {
    String input = message2.getMessage();
    String output = "";
    try {
      poly = new Polynomial(DVector.valueOf(input));
      CVector roots = poly.getRoots();
      for (int i = 0; i < roots.getDimension(); i++) {
        output += roots.get(i).toString(prec) + "\n";
      }
    } catch (Exception e) {
      output = "Error: " + e.getMessage();
    }
    message1.setMessage(output);
  }
}
