package physapps.mechanics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class BallisticThrow extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new BallisticThrow(), 580, 480);
  }

  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    polar2CartFunction1 = new physbeans.func.Polar2CartFunction();
    generic2DMassPoint1 = new physbeans.phys.Generic2DMassPoint();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    xYScope1 = new physbeans.inout.XYScope();
    outputPanel = new physbeans.inout.PhysicsPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();

    polar2CartFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        polar2CartFunction1ValueChanged(evt);
      }
    });

    generic2DMassPoint1.setFunctionX("-b*vx*sqrt(vx*vx+vy*vy)");
    generic2DMassPoint1.setFunctionY("-b*vy*sqrt(vx*vx+vy*vy) - m*g");
    generic2DMassPoint1.setParameter(DVector.valueOf("[9.81,0.5]"));
    generic2DMassPoint1.setParameterName(new String[] {"g", "b"});
    generic2DMassPoint1.setX0(DVector.valueOf("[0.0,0.0]"));
    generic2DMassPoint1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        generic2DMassPoint1ValueChanged(evt);
        generic2DMassPoint1ValueChanged1(evt);
      }
    });

    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    jPanel2.setFont(standardFont);
    objectPanel.setLayout(new java.awt.BorderLayout());

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    xYScope1.setBufferSize(10240);
    xYScope1.setDotSize(10);
    xYScope1.setLineColor(new Color[]{
      new Color(0, 0, 0),
      new Color(255, 0, 255),
      new Color(0, 255, 255),
      new Color(255, 175, 175),
      new Color(255, 200, 0),
      new Color(255, 0, 0),
      new Color(0, 0, 255),
      new Color(255, 255, 0)});
  xYScope1.setMaxX(200.0);
  xYScope1.setMaxY(100.0);
  xYScope1.setMinX(-10.0);
  xYScope1.setMinY(-10.0);
  xYScope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.mechanics.BallisticThrow", currentLocale).getString("osciPosition"));
  xYScope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.mechanics.BallisticThrow", currentLocale).getString("osciScale"));
  xYScope1.setScaleX(true);
  xYScope1.setScreenBackground(new java.awt.Color(255, 255, 255));
  xYScope1.setShowMarker(true);
  objectPanel.add(xYScope1, java.awt.BorderLayout.CENTER);

  jPanel2.add(objectPanel);

  outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.X_AXIS));

  outputPanel.setBackground(new java.awt.Color(150, 200, 255));
  outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
  outputPanel.setFont(standardFont);
  outputPanel.setOpaque(true);
  oscilloscope1.setNLines(4);
  oscilloscope1.setLineActive(new boolean[]{true,true,false,false});
  oscilloscope1.setMaxY(100.0);
  oscilloscope1.setMinY(-50.0);
  oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.mechanics.BallisticThrow", currentLocale).getString("osciPosition"));
  oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.mechanics.BallisticThrow", currentLocale).getString("osciScale"));
  oscilloscope1.setTimePerTick(0.05);
  outputPanel.add(oscilloscope1);

  jPanel2.add(outputPanel);

  jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

  inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

  inputPanel.setBackground(new java.awt.Color(100, 255, 255));
  inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
  inputPanel.setFont(standardFont);
  inputPanel.setOpaque(true);
  inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
  timer1.setDelay(30L);
  timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.mechanics.BallisticThrow", currentLocale).getString("timerLabel"));
  timer1.setTimeIncrement(0.05);
  timer1.addTimerListener(new physbeans.event.TimerListener() {
    public void nextStep(physbeans.event.NextStepEvent evt) {
      timer1NextStep(evt);
    }
    public void restart(physbeans.event.RestartEvent evt) {
      timer1Restart(evt);
      timer1Restart1(evt);
      timer1Restart2(evt);
    }
  });

  inputPanel.add(timer1);

  textSlider1.setDescription("v(0) =");
  textSlider1.setModel(new BoundedRealModel(0.0,40.0,100.0));
  textSlider1.setUnit("m/s");
  textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSlider1PropertyChange(evt);
    }
  });

  inputPanel.add(textSlider1);

  textSlider3.setDescription("\u03b1(0) =");
  textSlider3.setModel(new BoundedRealModel(0.0,0.25,0.5));
  textSlider3.setUnit("* \u03c0");
  textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSlider3PropertyChange(evt);
    }
  });

  inputPanel.add(textSlider3);

  textSlider2.setDescription("g =");
  textSlider2.setModel(new BoundedRealModel(0.0,9.81,20.0));
  textSlider2.setUnit("1/s\u00b2");
  textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSlider2PropertyChange(evt);
    }
  });

  inputPanel.add(textSlider2);

  textSlider4.setColumns(6);
  textSlider4.setDescription("b/m =");
  textSlider4.setLogarithmic(true);
  textSlider4.setModel(new BoundedRealModel(1.0E-5,0.0010,1.0));
  textSlider4.setUnit("1/m");
  textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSlider4PropertyChange(evt);
    }
  });

  inputPanel.add(textSlider4);

  switchBox1.setBoxLabel(new String[] {"x", "y", "vx", "vy"});
  switchBox1.setSelected(new boolean[]{true,true,false,false});
  switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.mechanics.BallisticThrow", currentLocale).getString("s1"));
  switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      switchBox1ValueChanged(evt);
    }
  });

  inputPanel.add(switchBox1);

  jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

  getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

  }// </editor-fold>//GEN-END:initComponents

  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    generic2DMassPoint1.setParameter(1, textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange

  private void timer1Restart2(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart2
    xYScope1.restart();
  }//GEN-LAST:event_timer1Restart2

  private void generic2DMassPoint1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_generic2DMassPoint1ValueChanged1
    xYScope1.setInputVector(generic2DMassPoint1.getPosition());
  }//GEN-LAST:event_generic2DMassPoint1ValueChanged1

  private void polar2CartFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_polar2CartFunction1ValueChanged
    generic2DMassPoint1.setV0(polar2CartFunction1.getOutputVector());
  }//GEN-LAST:event_polar2CartFunction1ValueChanged

  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    polar2CartFunction1.setPhi(textSlider3.getValue()*Math.PI);
  }//GEN-LAST:event_textSlider3PropertyChange

  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    polar2CartFunction1.setR(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange

  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    generic2DMassPoint1.setParameter(0, textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange

  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart1

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    generic2DMassPoint1.restart();
  }//GEN-LAST:event_timer1Restart

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged

  private void generic2DMassPoint1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_generic2DMassPoint1ValueChanged
    oscilloscope1.setInputVector(generic2DMassPoint1.getOutputVector());
  }//GEN-LAST:event_generic2DMassPoint1ValueChanged

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    generic2DMassPoint1.setTime(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.Generic2DMassPoint generic2DMassPoint1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.func.Polar2CartFunction polar2CartFunction1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.XYScope xYScope1;
  // End of variables declaration//GEN-END:variables
  
}
