package physapps.nonlinear;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class DrivenCoulombSpring extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new DrivenCoulombSpring(), 540, 565);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    coulombSpring1 = new physbeans.phys.CoulombSpring();
    harmonicVectorFunction1 = new physbeans.func.HarmonicFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    selector1 = new physbeans.func.Selector();
    springView1 = new physbeans.views.SpringView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    textSlider6 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    
    coulombSpring1.setExternalForceFunction(harmonicVectorFunction1);
    coulombSpring1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        coulombSpring1ValueChanged(evt);
      }
    });
    
    harmonicVectorFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        harmonicVectorFunction1ValueChanged(evt);
      }
    });
    
    multiplexer1.setInputLength(3);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });
    
    selector1.setIndex(new int[]{0,2});
    selector1.setInputLength(3);
    selector1.setOutputLength(2);
    selector1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        selector1ValueChanged(evt);
      }
    });
    
    springView1.setArrowScale(0.45);
    springView1.setEndLineLength(0.1);
    springView1.setFixPosition(-1.1);
    springView1.setMassHeight(0.15);
    springView1.setMassWidth(0.15);
    springView1.setShowArrow(true);
    springView1.setSpringWidth(0.3);
    springView1.setStartLineLength(0.03);
    springView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        springView1SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    layeredScreen1.setBackground(java.awt.Color.white);
    layeredScreen1.setBordered(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(1.1);
    layeredScreen1.setMinX(-1.1);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1);
    
    oscilloscope1.setNLines(3);
    oscilloscope1.setLineActive(new boolean[]{true,true,false});
    oscilloscope1.setMaxY(3.2);
    oscilloscope1.setMinY(-3.2);
    oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.nonlinear.DrivenCoulombSpring", currentLocale).getString("osciPosition"));
    oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.nonlinear.DrivenCoulombSpring", currentLocale).getString("osciScale"));
    outputPanel1.add(oscilloscope1);
    
    jPanel2.add(outputPanel1);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(30L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.nonlinear.DrivenCoulombSpring", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    textSlider1.setDescription("x(0) =");
    textSlider1.setModel(new BoundedRealModel(-2.0,0.0,2.0));
    textSlider1.setUnit("m");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("v(0) =");
    textSlider2.setModel(new BoundedRealModel(-2.0,0.0,2.0));
    textSlider2.setUnit("m/s");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("\u03bc =");
    textSlider3.setModel(new BoundedRealModel(0.0,0.08,0.25));
    textSlider3.setUnit("");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    textSlider4.setDescription("c/m =");
    textSlider4.setLogarithmic(true);
    textSlider4.setModel(new BoundedRealModel(0.1,1.0,10.0));
    textSlider4.setUnit("1/s\u00b2");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    textSlider5.setDescription("B/m =");
    textSlider5.setModel(new BoundedRealModel(0.0,1.0,2.0));
    textSlider5.setUnit("m/s\u00b2");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider5);
    
    textSlider6.setDescription(java.util.ResourceBundle.getBundle("physapps.nonlinear.DrivenCoulombSpring", currentLocale).getString("s5"));
    textSlider6.setModel(new BoundedRealModel(0.0,1.0,2.0));
    textSlider6.setUnit("1/s");
    textSlider6.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider6PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider6);
    
    switchBox1.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.nonlinear.DrivenCoulombSpring", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.nonlinear.DrivenCoulombSpring", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.nonlinear.DrivenCoulombSpring", currentLocale).getString("s3")
    });
    switchBox1.setSelected(new boolean[]{true,true,false});
    switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.nonlinear.DrivenCoulombSpring", currentLocale).getString("s4"));
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(switchBox1);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void coulombSpring1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_coulombSpring1ValueChanged
    DVector vec = coulombSpring1.getOutputVector();
    multiplexer1.setInputValues(0, vec.get(0));
    multiplexer1.setInputValues(1, vec.get(1));
  }//GEN-LAST:event_coulombSpring1ValueChanged
  
  private void springView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_springView1SourceChanged
    layeredScreen1.addView(springView1);
  }//GEN-LAST:event_springView1SourceChanged
  
  private void harmonicVectorFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_harmonicVectorFunction1ValueChanged
    multiplexer1.setInputValues(2, harmonicVectorFunction1.getOutputValue());
  }//GEN-LAST:event_harmonicVectorFunction1ValueChanged
    
  private void selector1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_selector1ValueChanged
    springView1.setModel(selector1.getOutputVector());
  }//GEN-LAST:event_selector1ValueChanged
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    DVector val = multiplexer1.getOutputVector();
    oscilloscope1.setInputVector(val);
    selector1.setInputVector(val);
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void textSlider6PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider6PropertyChange
    harmonicVectorFunction1.setOmega(textSlider6.getValue());
  }//GEN-LAST:event_textSlider6PropertyChange
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    double val = textSlider5.getValue();
    harmonicVectorFunction1.setAmplitude(val);
    springView1.setInitialValue(1, textSlider5.getValue());
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    coulombSpring1.setC(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    coulombSpring1.setMu(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    coulombSpring1.setV0(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    coulombSpring1.setX0(textSlider1.getValue());
    springView1.setInitialValue(0, textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    coulombSpring1.restart();
    oscilloscope1.restart();
    springView1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    double val = timer1.getTime();
    coulombSpring1.setTime(val);
    harmonicVectorFunction1.setInputValue(val);
  }//GEN-LAST:event_timer1NextStep
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.CoulombSpring coulombSpring1;
  protected physbeans.func.HarmonicFunction harmonicVectorFunction1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.func.Selector selector1;
  protected physbeans.views.SpringView springView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.TextSlider textSlider6;
  protected physbeans.inout.Timer timer1;
// End of variables declaration//GEN-END:variables
  
}
