package physapps.nonlinear;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.math.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel<br>
 *
 */
public class InitValuePendulum extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new InitValuePendulum(), 542, 500);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    mathPendulum1 = new physbeans.phys.MathPendulum();
    harmonicVectorFunction1 = new physbeans.func.HarmonicFunction();
    mathPendulum2 = new physbeans.phys.MathPendulum();
    harmonicVectorFunction2 = new physbeans.func.HarmonicFunction();
    arithmeticFunction1 = new physbeans.func.ArithmeticFunction();
    simpleMathFunction1 = new physbeans.func.SimpleMathFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    oscilloscope1 = new physbeans.inout.Oscilloscope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    switchBox1 = new physbeans.inout.SwitchBox();
    
    mathPendulum1.setB(1.0);
    mathPendulum1.setExternalTorqueFunction(harmonicVectorFunction1);
    mathPendulum1.setG(1.0);
    mathPendulum1.setAbsoluteTolerance(1.0E-9);
    mathPendulum1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        mathPendulum1ValueChanged(evt);
      }
    });
    
    mathPendulum2.setB(1.0);
    mathPendulum2.setExternalTorqueFunction(harmonicVectorFunction2);
    mathPendulum2.setG(1.0);
    mathPendulum2.setAbsoluteTolerance(1.0E-9);
    mathPendulum2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        mathPendulum2ValueChanged(evt);
      }
    });
    
    arithmeticFunction1.setFirstOp(1);
    arithmeticFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction1ValueChanged(evt);
      }
    });
    
    simpleMathFunction1.setFunctionType(7);
    simpleMathFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        simpleMathFunction1ValueChanged(evt);
      }
    });
    
    multiplexer1.setInputLength(3);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    oscilloscope1.setNLines(3);
    oscilloscope1.setLineActive(new boolean[]{true,true,false});
    oscilloscope1.setMaxY(20.0);
    oscilloscope1.setMinY(-20.0);
    oscilloscope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.nonlinear.InitValuePendulum", currentLocale).getString("osciPosition"));
    oscilloscope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.nonlinear.InitValuePendulum", currentLocale).getString("osciScale"));
    objectPanel1.add(oscilloscope1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(15L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.nonlinear.InitValuePendulum", currentLocale).getString("timerLabel"));
    timer1.setTimeIncrement(0.5);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    textSlider1.setColumns(8);
    textSlider1.setDescription("\u03c61(0) =");
    textSlider1.setModel(new BoundedRealModel(-1.0,0.0,1.0));
    textSlider1.setUnit("* \u03c0");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setColumns(8);
    textSlider2.setDescription("\u03c62(0) =");
    textSlider2.setModel(new BoundedRealModel(-1.0,0.01,1.0));
    textSlider2.setUnit("* \u03c0");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("\u03bb =");
    textSlider3.setModel(new BoundedRealModel(0.0,0.5,2.0));
    textSlider3.setUnit("");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    textSlider4.setDescription("A =");
    textSlider4.setModel(new BoundedRealModel(0.0,1.2,2.0));
    textSlider4.setUnit("");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    textSlider5.setDescription("\u03c9_ext =");
    textSlider5.setModel(new BoundedRealModel(0.0,0.667,2.0));
    textSlider5.setUnit("");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider5);
    
    switchBox1.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.nonlinear.InitValuePendulum", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.nonlinear.InitValuePendulum", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.nonlinear.InitValuePendulum", currentLocale).getString("s3")
    });
    switchBox1.setSelected(new boolean[]{true,true,false});
    switchBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.nonlinear.InitValuePendulum", currentLocale).getString("s4"));
    switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        switchBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(switchBox1);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void mathPendulum2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_mathPendulum2ValueChanged
    double val = mathPendulum2.getOutputValues(0);
    arithmeticFunction1.setSecondArg(val);
    multiplexer1.setInputValues(1, val);
  }//GEN-LAST:event_mathPendulum2ValueChanged
  
  private void mathPendulum1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_mathPendulum1ValueChanged
    double val = mathPendulum1.getOutputValues(0);
    arithmeticFunction1.setFirstArg(val);
    multiplexer1.setInputValues(0, val);
  }//GEN-LAST:event_mathPendulum1ValueChanged
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    oscilloscope1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void simpleMathFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_simpleMathFunction1ValueChanged
    multiplexer1.setInputValues(2, simpleMathFunction1.getOutputValue());
  }//GEN-LAST:event_simpleMathFunction1ValueChanged
  
  private void arithmeticFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction1ValueChanged
    simpleMathFunction1.setInputValue(arithmeticFunction1.getResult());
  }//GEN-LAST:event_arithmeticFunction1ValueChanged
  
  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    oscilloscope1.setLineActive(switchBox1.getSelected());
  }//GEN-LAST:event_switchBox1ValueChanged
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    double val = textSlider5.getValue();
    harmonicVectorFunction1.setOmega(val);
    harmonicVectorFunction2.setOmega(val);
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double val = textSlider4.getValue();
    harmonicVectorFunction1.setAmplitude(val);
    harmonicVectorFunction2.setAmplitude(val);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    double val = textSlider3.getValue();
    mathPendulum1.setB(val);
    mathPendulum2.setB(val);
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    mathPendulum2.setPhi0(textSlider2.getValue()*Math.PI);
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    mathPendulum1.setPhi0(textSlider1.getValue()*Math.PI);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    mathPendulum1.restart();
    mathPendulum2.restart();
    oscilloscope1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    double val = timer1.getTime();
    mathPendulum1.setInputValue(val);
    mathPendulum2.setInputValue(val);
  }//GEN-LAST:event_timer1NextStep
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.ArithmeticFunction arithmeticFunction1;
  protected physbeans.func.HarmonicFunction harmonicVectorFunction1;
  protected physbeans.func.HarmonicFunction harmonicVectorFunction2;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.phys.MathPendulum mathPendulum1;
  protected physbeans.phys.MathPendulum mathPendulum2;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.Oscilloscope oscilloscope1;
  protected physbeans.func.SimpleMathFunction simpleMathFunction1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.Timer timer1;
// End of variables declaration//GEN-END:variables
  
}
