package physapps.optics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel in "high" layout.
 */
public class LensErrors extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new LensErrors(), 650, 420);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    planeLightSource1 = new physbeans.phys.PlaneLightSource();
    planeLightSourceView1 = new physbeans.views.PlaneLightSourceView();
    lens1 = new physbeans.phys.Lens();
    lensView1 = new physbeans.views.LensView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    jPanel1 = new javax.swing.JPanel();
    inputPanel = new physbeans.inout.PhysicsPanel();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    integerTextSlider1 = new physbeans.inout.IntegerTextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider6 = new physbeans.inout.TextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    
    planeLightSource1.setPosition(-20.0);
    planeLightSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        planeLightSource1SourceChanged(evt);
      }
    });
    
    planeLightSourceView1.setDepth(40);
    lens1.setMaxHeight(8.0);
    lens1.setRadius1(40.0);
    lens1.setRadius2(-40.0);
    lens1.setThickness(2.0);
    lens1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lens1SourceChanged(evt);
      }
    });
    
    lensView1.setDepth(60);
    lensView1.setFocalPointRadius(0.5);
    lensView1.setShowPrincipalPlane(false);
    lensView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lensView1SourceChanged(evt);
      }
    });
    
    simpleFigureView1.setFigureType(0);
    simpleFigureView1.setP1(DVector.valueOf("[-30.0,0.0]"));
    simpleFigureView1.setP2(DVector.valueOf("[30.0,0.0]"));
    
    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel.setLayout(new java.awt.GridLayout(2, 3));
    
    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    textSlider1.setDescription("w =");
    textSlider1.setModel(new BoundedRealModel(0.0,12.0,20.0));
    textSlider1.setUnit("cm");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel.add(textSlider1);
    
    textSlider3.setDescription("r1 =");
    textSlider3.setModel(new BoundedRealModel(-60.0,20.0,60.0));
    textSlider3.setUnit("cm");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel.add(textSlider3);
    
    textSlider2.setDescription("d =");
    textSlider2.setModel(new BoundedRealModel(0.1,5.0,15.0));
    textSlider2.setUnit("cm");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel.add(textSlider2);
    
    integerTextSlider1.setDescription("nr =");
    integerTextSlider1.setModel(new BoundedRealModel(0.0,10.0,50.0));
    integerTextSlider1.setUnit("");
    integerTextSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        integerTextSlider1PropertyChange(evt);
      }
    });
    
    inputPanel.add(integerTextSlider1);
    
    textSlider4.setDescription("r2 =");
    textSlider4.setModel(new BoundedRealModel(-60.0,-20.0,40.0));
    textSlider4.setUnit("cm");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel.add(textSlider4);
    
    textSlider6.setDescription("n =");
    textSlider6.setModel(new BoundedRealModel(1.0,1.6,3.0));
    textSlider6.setUnit("");
    textSlider6.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider6PropertyChange(evt);
      }
    });
    
    inputPanel.add(textSlider6);
    
    jPanel1.add(inputPanel);
    
    objectPanel1.setBordered(true);
    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 200));
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setMaxX(30.0);
    layeredScreen1.setMaxY(10.5);
    layeredScreen1.setMinX(-30.0);
    layeredScreen1.setMinY(-10.5);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(objectPanel1);
    
    outputPanel1.setLayout(new java.awt.FlowLayout());
    
    outputPanel1.setPreferredSize(new java.awt.Dimension(50, 1));
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(30);
    vectorTextField1.setUnit(new String[] {"cm", "cm"});
    outputPanel1.add(vectorTextField1);
    
    jPanel1.add(outputPanel1);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void lensView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lensView1SourceChanged
    layeredScreen1.addView(lensView1);
    layeredScreen1.addView(simpleFigureView1);
    layeredScreen1.addView(planeLightSourceView1);
  }//GEN-LAST:event_lensView1SourceChanged
  
  private void integerTextSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_integerTextSlider1PropertyChange
    planeLightSource1.setNRays(integerTextSlider1.getValueAsInt());
  }//GEN-LAST:event_integerTextSlider1PropertyChange
  
  private void textSlider6PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider6PropertyChange
    lens1.setIndexOfRefraction(textSlider6.getValue());
  }//GEN-LAST:event_textSlider6PropertyChange
  
  private void planeLightSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_planeLightSource1SourceChanged
    planeLightSourceView1.setModel(planeLightSource1);
    lens1.propagate(planeLightSource1.getRays());
  }//GEN-LAST:event_planeLightSource1SourceChanged
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    lens1.setRadius2(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    lens1.setRadius1(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void lens1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lens1SourceChanged
    lensView1.setModel(lens1);
    planeLightSource1.trigger();
  }//GEN-LAST:event_lens1SourceChanged
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    lens1.setThickness(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    planeLightSource1.setWidth(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected physbeans.inout.IntegerTextSlider integerTextSlider1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.Lens lens1;
  protected physbeans.views.LensView lensView1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PlaneLightSource planeLightSource1;
  protected physbeans.views.PlaneLightSourceView planeLightSourceView1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider6;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
