package physapps.optics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel in "high" layout.
 */
public class LensImage extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new LensImage(), 650, 420);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    pointLightSource1 = new physbeans.phys.PointLightSource();
    pointLightSourceView1 = new physbeans.views.PointLightSourceView();
    lens1 = new physbeans.phys.Lens();
    lensView1 = new physbeans.views.LensView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    jPanel1 = new javax.swing.JPanel();
    physicsPanel2 = new physbeans.inout.PhysicsPanel();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider6 = new physbeans.inout.TextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    
    pointLightSource1.setNRays(9);
    pointLightSource1.setPosition(-20.0);
    pointLightSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointLightSource1SourceChanged(evt);
      }
    });
    
    pointLightSourceView1.setDepth(40);
    pointLightSourceView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointLightSourceView1SourceChanged(evt);
      }
    });
    
    lens1.setMaxHeight(10.0);
    lens1.setRadius1(40.0);
    lens1.setRadius2(-40.0);
    lens1.setThickness(2.0);
    lens1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lens1SourceChanged(evt);
      }
    });
    
    lensView1.setDepth(60);
    lensView1.setFocalPointRadius(0.5);
    lensView1.setShowPrincipalPlane(false);
    simpleFigureView1.setFigureType(0);
    simpleFigureView1.setP1(DVector.valueOf("[-30.0,0.0]"));
    simpleFigureView1.setP2(DVector.valueOf("[30.0,0.0]"));
    
    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    physicsPanel2.setLayout(new java.awt.GridLayout(2, 3));
    
    physicsPanel2.setBackground(new java.awt.Color(100, 255, 255));
    physicsPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    physicsPanel2.setFont(standardFont);
    physicsPanel2.setOpaque(true);
    textSlider3.setDescription("x =");
    textSlider3.setModel(new BoundedRealModel(-60.0,-20.0,0.0));
    textSlider3.setUnit("cm");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    physicsPanel2.add(textSlider3);
    
    textSlider1.setDescription("\u03b1 =");
    textSlider1.setModel(new BoundedRealModel(0.0,0.065,0.5));
    textSlider1.setUnit("* \u03c0");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    physicsPanel2.add(textSlider1);
    
    textSlider2.setDescription("d =");
    textSlider2.setModel(new BoundedRealModel(0.1,5.0,15.0));
    textSlider2.setUnit("cm");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    physicsPanel2.add(textSlider2);
    
    textSlider5.setDescription("y =");
    textSlider5.setModel(new BoundedRealModel(-15.0,1.0,15.0));
    textSlider5.setUnit("cm");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
      }
    });
    
    physicsPanel2.add(textSlider5);
    
    textSlider4.setDescription("r =");
    textSlider4.setModel(new BoundedRealModel(0.0,20.0,60.0));
    textSlider4.setUnit("cm");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    physicsPanel2.add(textSlider4);
    
    textSlider6.setDescription("n =");
    textSlider6.setModel(new BoundedRealModel(1.0,2.0,3.0));
    textSlider6.setUnit("");
    textSlider6.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider6PropertyChange(evt);
      }
    });
    
    physicsPanel2.add(textSlider6);
    
    jPanel1.add(physicsPanel2);
    
    objectPanel1.setBordered(true);
    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 200));
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setMaxX(30.0);
    layeredScreen1.setMaxY(10.5);
    layeredScreen1.setMinX(-30.0);
    layeredScreen1.setMinY(-10.5);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(objectPanel1);
    
    outputPanel1.setLayout(new java.awt.FlowLayout());
    
    outputPanel1.setPreferredSize(new java.awt.Dimension(50, 1));
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(30);
    vectorTextField1.setUnit(new String[] {"cm", "cm"});
    outputPanel1.add(vectorTextField1);
    
    jPanel1.add(outputPanel1);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void pointLightSourceView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointLightSourceView1SourceChanged
    layeredScreen1.addView(lensView1);
    layeredScreen1.addView(simpleFigureView1);
    layeredScreen1.addView(pointLightSourceView1);
  }//GEN-LAST:event_pointLightSourceView1SourceChanged
  
  private void pointLightSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointLightSource1SourceChanged
    pointLightSourceView1.setModel(pointLightSource1);
    lens1.propagate(pointLightSource1.getRays());
  }//GEN-LAST:event_pointLightSource1SourceChanged
  
  private void textSlider6PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider6PropertyChange
    lens1.setIndexOfRefraction(textSlider6.getValue());
  }//GEN-LAST:event_textSlider6PropertyChange
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    pointLightSource1.setHeight(textSlider5.getValue());
  }//GEN-LAST:event_textSlider5PropertyChange
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    double val = textSlider4.getValue();
    lens1.setRadius1(val);
    lens1.setRadius2(-val);
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    pointLightSource1.setPosition(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void lens1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lens1SourceChanged
    lensView1.setModel(lens1);
    pointLightSource1.trigger();
  }//GEN-LAST:event_lens1SourceChanged
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    lens1.setThickness(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    pointLightSource1.setSpreadAngle(textSlider1.getValue()*Math.PI);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.Lens lens1;
  protected physbeans.views.LensView lensView1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.inout.PhysicsPanel physicsPanel2;
  protected physbeans.phys.PointLightSource pointLightSource1;
  protected physbeans.views.PointLightSourceView pointLightSourceView1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.TextSlider textSlider6;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
