package physapps.optics;
import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel in "high" layout.
 */
public class VerticalGlassPlane extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new VerticalGlassPlane(), 620, 420);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    pointLightSource1 = new physbeans.phys.PointLightSource();
    pointLightSourceView1 = new physbeans.views.PointLightSourceView();
    glassPlane1 = new physbeans.phys.GlassPlane();
    glassPlaneView1 = new physbeans.views.GlassPlaneView();
    jPanel1 = new javax.swing.JPanel();
    inputPanel1 = new physbeans.inout.InputPanel();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    
    pointLightSource1.setNRays(9);
    pointLightSource1.setHeight(-2.0);
    pointLightSource1.setMidAngle(0.2);
    pointLightSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        pointLightSource1SourceChanged(evt);
        pointLightSource1SourceChanged1(evt);
      }
    });
    
    glassPlane1.setIndexOfRefraction(1.8);
    glassPlane1.setWidth(2.0);
    glassPlane1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        glassPlane1SourceChanged(evt);
        glassPlane1SourceChanged1(evt);
      }
    });
    
    glassPlaneView1.setDepth(60);
    glassPlaneView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        glassPlaneView1SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    inputPanel1.setLayout(new java.awt.GridLayout(2, 2));
    
    inputPanel1.setAlignmentX(0.5F);
    textSlider1.setDescription("x =");
    textSlider1.setModel(new BoundedRealModel(-10.0,-5.0,10.0));
    textSlider1.setUnit("m");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("d =");
    textSlider2.setModel(new BoundedRealModel(0.0,2.0,15.0));
    textSlider2.setUnit("m");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("\u03b1 =");
    textSlider3.setModel(new BoundedRealModel(-1.0,0.0,1.0));
    textSlider3.setUnit("\u03c0");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    textSlider4.setDescription("n =");
    textSlider4.setModel(new BoundedRealModel(1.0,1.5,3.0));
    textSlider4.setUnit("");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    jPanel1.add(inputPanel1);
    
    objectPanel1.setPreferredSize(new java.awt.Dimension(200, 250));
    layeredScreen1.setCrossCursor(true);
    layeredScreen1.setEqualScales(true);
    layeredScreen1.setMaxX(10.0);
    layeredScreen1.setMinX(-10.0);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
      }
    });
    
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel1.add(objectPanel1);
    
    outputPanel1.setLayout(new java.awt.FlowLayout());
    
    vectorTextField1.setHorizontal(true);
    vectorTextField1.setPadding(30);
    outputPanel1.add(vectorTextField1);
    
    jPanel1.add(outputPanel1);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents
  
  private void glassPlaneView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_glassPlaneView1SourceChanged
    layeredScreen1.addView(glassPlaneView1);
    layeredScreen1.addView(pointLightSourceView1);
  }//GEN-LAST:event_glassPlaneView1SourceChanged
  
  private void glassPlane1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_glassPlane1SourceChanged1
    glassPlaneView1.setModel(glassPlane1);
  }//GEN-LAST:event_glassPlane1SourceChanged1
  
  private void glassPlane1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_glassPlane1SourceChanged
    pointLightSource1.trigger();
  }//GEN-LAST:event_glassPlane1SourceChanged
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    glassPlane1.setIndexOfRefraction(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    glassPlane1.setWidth(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void pointLightSource1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointLightSource1SourceChanged1
    glassPlane1.propagate(pointLightSource1.getRays());
  }//GEN-LAST:event_pointLightSource1SourceChanged1
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    pointLightSource1.setMidAngle(textSlider3.getValue()*Math.PI);
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    pointLightSource1.setPosition(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void pointLightSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_pointLightSource1SourceChanged
    pointLightSourceView1.setModel(pointLightSource1);
  }//GEN-LAST:event_pointLightSource1SourceChanged
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.phys.GlassPlane glassPlane1;
  protected physbeans.views.GlassPlaneView glassPlaneView1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PointLightSource pointLightSource1;
  protected physbeans.views.PointLightSourceView pointLightSourceView1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.VectorTextField vectorTextField1;
// End of variables declaration//GEN-END:variables
  
}
