package physapps.quantummechanics;

import physbeans.inout.*;
import physbeans.math.*;
import physbeans.phys.*;
import physbeans.model.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class CoulombPolarGaussian extends PhysBeansApplet {

  static public void main(String[] args) {
    startApp(new CoulombPolarGaussian(), 580, 625);
  }

  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    schroedinger2DPML1 = new physbeans.phys.Schroedinger2DPML();
    coulomb2DPotential1 = new physbeans.phys.Coulomb2DPotential();
    polarGaussianGridInitializer1 = new physbeans.phys.PolarGaussianGridInitializer();
    jetColorTable1 = new physbeans.views.JetColorTable();
    complexGridView1 = new physbeans.views.ComplexGridView();
    simpleFigureView1 = new physbeans.views.SimpleFigureView();
    labelView1 = new physbeans.views.LabelView();
    complexToRealFunctionAdapter1 = new physbeans.func.ComplexToRealFunctionAdapter();
    obliqueCutFunction1 = new physbeans.func.ObliqueCutFunction();
    functionView1 = new physbeans.views.FunctionView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    controlledLayeredScreen1 = new physbeans.inout.ControlledLayeredScreen();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    textSliderR = new physbeans.inout.TextSlider();
    textSliderDR = new physbeans.inout.TextSlider();
    textSliderPhi = new physbeans.inout.TextSlider();
    textSliderDPhi = new physbeans.inout.TextSlider();
    textSliderLz = new physbeans.inout.TextSlider();
    radioButtonBox1 = new physbeans.inout.RadioButtonBox();
    switchBox1 = new physbeans.inout.SwitchBox();
    textSlider2 = new physbeans.inout.TextSlider();

    schroedinger2DPML1.setXMax(7.0E-9);
    schroedinger2DPML1.setXMin(-7.0E-9);
    schroedinger2DPML1.setYMax(7.0E-9);
    schroedinger2DPML1.setYMin(-7.0E-9);
    schroedinger2DPML1.setInitFunction(polarGaussianGridInitializer1);
    schroedinger2DPML1.setPotential(coulomb2DPotential1);
    schroedinger2DPML1.setTimeIncrement(2.0E-16);
    schroedinger2DPML1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        schroedinger2DPML1SourceChanged(evt);
      }
    });

    complexGridView1.setColors(jetColorTable1);
    complexGridView1.setDepth(60);
    complexGridView1.setMaxVal(2.0E8);
    complexGridView1.setMinVal(-2.0E8);
    complexGridView1.setType(ComplexToRealEnum.ABS2);
    complexGridView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        complexGridView1SourceChanged(evt);
      }
    });

    simpleFigureView1.setFigureType(0);
    simpleFigureView1.setP1(DVector.valueOf("[-7.0E-9,0.0]"));
    simpleFigureView1.setP2(DVector.valueOf("[7.0E-9,0.0]"));
    simpleFigureView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        simpleFigureView1SourceChanged(evt);
      }
    });

    labelView1.setDepth(40);
    labelView1.setInitialValues(new String[] {"0.0"});
    labelView1.setMarginLeft(0.0);
    labelView1.setMarginRight(0.0);
    labelView1.setPadding(0.0);
    labelView1.setPrecision(3);
    labelView1.setTextColor(new java.awt.Color(255, 0, 0));
    labelView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        labelView1SourceChanged(evt);
      }
    });

    complexToRealFunctionAdapter1.setYMax(8.0E8);
    complexToRealFunctionAdapter1.setYMin(-8.0E8);
    complexToRealFunctionAdapter1.setConversionType(ComplexToRealEnum.ABS);
    complexToRealFunctionAdapter1.setCutoff(1.0E7);
    complexToRealFunctionAdapter1.setScreen(controlledLayeredScreen1);
    complexToRealFunctionAdapter1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        complexToRealFunctionAdapter1ValueChanged(evt);
      }
    });

    obliqueCutFunction1.setAlpha(0.0);
    obliqueCutFunction1.setLength(1.4E-8);
    obliqueCutFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        obliqueCutFunction1ValueChanged(evt);
      }
    });

    functionView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        functionView1SourceChanged(evt);
      }
    });

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(3, 3, 3, 3));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    objectPanel.setPreferredSize(new java.awt.Dimension(106, 300));
    objectPanel.setLayout(new java.awt.BorderLayout());

    layeredScreen1.setMaxX(7.0E-9);
    layeredScreen1.setMaxY(7.0E-9);
    layeredScreen1.setMinX(-7.0E-9);
    layeredScreen1.setMinY(-7.0E-9);
    layeredScreen1.setViewActive(new boolean[] {true, false, true});
    objectPanel.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel);

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    outputPanel.setPreferredSize(new java.awt.Dimension(316, 200));
    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.Y_AXIS));

    controlledLayeredScreen1.setBordered(true);
    controlledLayeredScreen1.setMaxX(4.0E-9);
    controlledLayeredScreen1.setMinX(-4.0E-9);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.quantummechanics.CoulombPolarGaussian", currentLocale); // NOI18N
    controlledLayeredScreen1.setPositionLabel(bundle.getString("osciPosition")); // NOI18N
    controlledLayeredScreen1.setScaleLabel(bundle.getString("osciScale")); // NOI18N
    outputPanel.add(controlledLayeredScreen1);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    inputPanel.setPreferredSize(new java.awt.Dimension(217, 200));
    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    timer1.setDelay(30L);
    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.setTimeIncrement(2.0E-16);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
        timer1NextStep2(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel.add(timer1);

    textSliderR.setColumns(6);
    textSliderR.setDescription("r\u2080 =");
    textSliderR.setModel(new BoundedRealModel(1.0E-10,1.5E-9,5.0E-9));
    textSliderR.setUnit("m");
    textSliderR.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderRPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderR);

    textSliderDR.setColumns(6);
    textSliderDR.setDescription("dr =");
    textSliderDR.setModel(new BoundedRealModel(1.0E-10,4.0E-10,2.0E-9));
    textSliderDR.setUnit("m");
    textSliderDR.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderDRPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderDR);

    textSliderPhi.setColumns(6);
    textSliderPhi.setDescription("\u03c6\u2080 =");
    textSliderPhi.setModel(new BoundedRealModel(-1.0,0.0,1.0));
    textSliderPhi.setUnit("* \u03c0");
    textSliderPhi.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderPhiPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderPhi);

    textSliderDPhi.setColumns(6);
    textSliderDPhi.setDescription("d\u03c6 =");
    textSliderDPhi.setModel(new BoundedRealModel(-4.0,1.0,4.0));
    textSliderDPhi.setUnit("");
    textSliderDPhi.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderDPhiPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderDPhi);

    textSliderLz.setColumns(6);
    textSliderLz.setDescription("Lz =");
    textSliderLz.setModel(new BoundedRealModel(-10.0,5.0,10.0));
    textSliderLz.setUnit("");
    textSliderLz.setUnitIcon("physbeans/resources/hbar.gif");
    textSliderLz.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderLzPropertyChange(evt);
      }
    });
    inputPanel.add(textSliderLz);

    radioButtonBox1.setBoxLabel( new String[] {
      bundle.getString("real"), bundle.getString("imag"), bundle.getString("abs"),
      bundle.getString("abs2"), bundle.getString("phase")
    }
  );
  radioButtonBox1.setSelected(3);
  radioButtonBox1.setTitle(bundle.getString("Display")); // NOI18N
  radioButtonBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      radioButtonBox1ValueChanged(evt);
    }
  });
  inputPanel.add(radioButtonBox1);

  switchBox1.setBoxLabel( new String[] {bundle.getString("s1")}
  );
  switchBox1.setSelected(new boolean[] {false});
  switchBox1.setTitle("");
  switchBox1.addSwitchListener(new physbeans.event.SwitchListener() {
    public void valueChanged(physbeans.event.SwitchEvent evt) {
      switchBox1ValueChanged(evt);
    }
  });
  inputPanel.add(switchBox1);

  textSlider2.setColumns(6);
  textSlider2.setDescription("\u03b1 =");
  textSlider2.setModel(new BoundedRealModel(-0.5,0.0,0.5));
  textSlider2.setUnit("* \u03c0");
  textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
    public void propertyChange(java.beans.PropertyChangeEvent evt) {
      textSlider2PropertyChange(evt);
    }
  });
  inputPanel.add(textSlider2);

  jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

  getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    schroedinger2DPML1.nextStep();
  }//GEN-LAST:event_timer1NextStep

  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    schroedinger2DPML1.restart();
    labelView1.restart();
  }//GEN-LAST:event_timer1Restart

  private void functionView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_functionView1SourceChanged
    controlledLayeredScreen1.addView(functionView1);
  }//GEN-LAST:event_functionView1SourceChanged

  private void complexGridView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_complexGridView1SourceChanged
    layeredScreen1.addView(complexGridView1);
  }//GEN-LAST:event_complexGridView1SourceChanged

  private void complexToRealFunctionAdapter1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_complexToRealFunctionAdapter1ValueChanged
    obliqueCutFunction1.setScalarField(complexToRealFunctionAdapter1);
  }//GEN-LAST:event_complexToRealFunctionAdapter1ValueChanged

  private void radioButtonBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBox1ValueChanged
    complexToRealFunctionAdapter1.setConversionTypeFromInt(radioButtonBox1.getSelected());
    complexGridView1.setTypeFromInt(radioButtonBox1.getSelected());
}//GEN-LAST:event_radioButtonBox1ValueChanged

  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    double val = textSlider2.getValue()*Math.PI;
    obliqueCutFunction1.setAlpha(val);
    simpleFigureView1.setAngle(val);
  }//GEN-LAST:event_textSlider2PropertyChange

  private void simpleFigureView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_simpleFigureView1SourceChanged
    layeredScreen1.addView(simpleFigureView1);
  }//GEN-LAST:event_simpleFigureView1SourceChanged

  private void switchBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_switchBox1ValueChanged
    layeredScreen1.setViewActive(1, switchBox1.getSelected(0));
  }//GEN-LAST:event_switchBox1ValueChanged

  private void textSliderDRPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderDRPropertyChange
    polarGaussianGridInitializer1.setRadialWidth(textSliderDR.getValue());
  }//GEN-LAST:event_textSliderDRPropertyChange

  private void textSliderRPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderRPropertyChange
    polarGaussianGridInitializer1.setR0(textSliderR.getValue());
  }//GEN-LAST:event_textSliderRPropertyChange

  private void textSliderPhiPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderPhiPropertyChange
    polarGaussianGridInitializer1.setPhi0(textSliderPhi.getValue() * Math.PI);
  }//GEN-LAST:event_textSliderPhiPropertyChange

  private void textSliderDPhiPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderDPhiPropertyChange
    polarGaussianGridInitializer1.setAngularWidth(textSliderDPhi.getValue());
  }//GEN-LAST:event_textSliderDPhiPropertyChange

  private void textSliderLzPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderLzPropertyChange
    polarGaussianGridInitializer1.setLz(textSliderLz.getValue() * Constants.HBAR);
  }//GEN-LAST:event_textSliderLzPropertyChange

  private void schroedinger2DPML1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_schroedinger2DPML1SourceChanged
    complexGridView1.setModel(schroedinger2DPML1);
    complexToRealFunctionAdapter1.setComplexFunction(schroedinger2DPML1);
  }//GEN-LAST:event_schroedinger2DPML1SourceChanged

  private void labelView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_labelView1SourceChanged
    layeredScreen1.addView(labelView1);
  }//GEN-LAST:event_labelView1SourceChanged

  private void timer1NextStep2(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep2
    labelView1.setValue(timer1.getTime());
  }//GEN-LAST:event_timer1NextStep2

  private void obliqueCutFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_obliqueCutFunction1ValueChanged
    functionView1.setModel(obliqueCutFunction1.getXVector(), obliqueCutFunction1.getYVector());
  }//GEN-LAST:event_obliqueCutFunction1ValueChanged
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.ComplexGridView complexGridView1;
  protected physbeans.func.ComplexToRealFunctionAdapter complexToRealFunctionAdapter1;
  protected physbeans.inout.ControlledLayeredScreen controlledLayeredScreen1;
  protected physbeans.phys.Coulomb2DPotential coulomb2DPotential1;
  protected physbeans.views.FunctionView functionView1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.views.JetColorTable jetColorTable1;
  protected physbeans.views.LabelView labelView1;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.func.ObliqueCutFunction obliqueCutFunction1;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.phys.PolarGaussianGridInitializer polarGaussianGridInitializer1;
  protected physbeans.inout.RadioButtonBox radioButtonBox1;
  protected physbeans.phys.Schroedinger2DPML schroedinger2DPML1;
  protected physbeans.views.SimpleFigureView simpleFigureView1;
  protected physbeans.inout.SwitchBox switchBox1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSliderDPhi;
  protected physbeans.inout.TextSlider textSliderDR;
  protected physbeans.inout.TextSlider textSliderLz;
  protected physbeans.inout.TextSlider textSliderPhi;
  protected physbeans.inout.TextSlider textSliderR;
  protected physbeans.inout.Timer timer1;
  // End of variables declaration//GEN-END:variables
}
