package physapps.thermodynamics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.phys.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class GasTurbineEnergies extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new GasTurbineEnergies(), 560, 470);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    cyclicProcess1 = new physbeans.phys.CyclicProcess();
    perfectGas1 = new physbeans.phys.PerfectGas();
    arithmeticFunction1 = new physbeans.func.ArithmeticFunction();
    arithmeticFunction2 = new physbeans.func.ArithmeticFunction();
    multiplexer1 = new physbeans.func.Multiplexer();
    multiplexer2 = new physbeans.func.Multiplexer();
    multiplexer3 = new physbeans.func.Multiplexer();
    barView1 = new physbeans.views.BarView();
    labelView1 = new physbeans.views.LabelView();
    labelView2 = new physbeans.views.LabelView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    controlledLayeredScreen1 = new physbeans.inout.ControlledLayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    xYScope1 = new physbeans.inout.XYScope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();
    textSlider5 = new physbeans.inout.TextSlider();
    
    cyclicProcess1.setNSteps(new int[]{100,100,100,100});
    cyclicProcess1.setPoints(DVector.valueOf("[2.0,0.11111,0.2]"));
    cyclicProcess1.setPolytropicExponents(DVector.valueOf("[1.4,0.0,1.4,0.0]"));
    cyclicProcess1.setStartPressure(100000.0);
    cyclicProcess1.setSystem(perfectGas1);
    perfectGas1.setAutoReset(false);
    perfectGas1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        perfectGas1SourceChanged(evt);
        perfectGas1SourceChanged1(evt);
      }
    });
    
    arithmeticFunction1.setAssociativity(4);
    arithmeticFunction1.setFirstOp(3);
    arithmeticFunction1.setSecondOp(5);
    arithmeticFunction1.setThirdArg(1.0);
    arithmeticFunction1.setThirdOp(3);
    arithmeticFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction1ValueChanged(evt);
      }
    });
    
    arithmeticFunction2.setAssociativity(1);
    arithmeticFunction2.setFirstOp(2);
    arithmeticFunction2.setSecondArg(287.2);
    arithmeticFunction2.setSecondOp(3);
    arithmeticFunction2.setThirdOp(2);
    arithmeticFunction2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        arithmeticFunction2ValueChanged(evt);
      }
    });
    
    multiplexer1.setInputLength(3);
    multiplexer1.setCollectInput(false);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });
    
    multiplexer2.setAutoTriggered(false);
    multiplexer2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer2ValueChanged(evt);
      }
    });
    
    multiplexer3.setInputLength(5);
    multiplexer3.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer3ValueChanged(evt);
      }
    });
    
    barView1.setBarWidth(0.8);
    barView1.setEqualBarColor(false);
    barView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        barView1SourceChanged(evt);
        barView1SourceChanged1(evt);
      }
    });
    
    labelView1.setDepth(40);
    labelView1.setPrecision(3);
    labelView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        labelView1SourceChanged(evt);
        labelView1SourceChanged1(evt);
      }
    });
    
    labelView2.setDepth(30);
    labelView2.setInitialValues(new String[] {"U", "Wv", "Q", "Wt", "H"});
    labelView2.setPosition(1.0);
    labelView2.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        labelView2SourceChanged(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    controlledLayeredScreen1.setBordered(true);
    controlledLayeredScreen1.setMaxX(4.9);
    controlledLayeredScreen1.setMaxY(1000000.0);
    controlledLayeredScreen1.setMinX(-0.1);
    controlledLayeredScreen1.setMinY(-550000.0);
    controlledLayeredScreen1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.GasTurbineEnergies", currentLocale).getString("osciPosition"));
    controlledLayeredScreen1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.GasTurbineEnergies", currentLocale).getString("osciScale"));
    controlledLayeredScreen1.setViewActive(new boolean[]{true,true,true});
    objectPanel1.add(controlledLayeredScreen1, java.awt.BorderLayout.CENTER);
    
    jPanel2.add(objectPanel1);
    
    xYScope1.setBufferSize(5000);
    xYScope1.setDotSize(6);
    xYScope1.setMaxX(3.2);
    xYScope1.setMaxY(800000.0);
    xYScope1.setMinX(0.0);
    xYScope1.setMinY(0.0);
    xYScope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.GasTurbineEnergies", currentLocale).getString("osciPosition"));
    xYScope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.GasTurbineEnergies", currentLocale).getString("osciScale"));
    xYScope1.setShowMarker(true);
    outputPanel1.add(xYScope1);
    
    jPanel2.add(outputPanel1);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setDelay(30L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.thermodynamics.GasTurbineEnergies", currentLocale).getString("timerLabel"));
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    textSlider1.setDescription("p1 =");
    textSlider1.setModel(new BoundedRealModel(50000.0,100000.0,600000.0));
    textSlider1.setUnit("Pa");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("V1 =");
    textSlider2.setModel(new BoundedRealModel(0.5,0.8702,1.5));
    textSlider2.setUnit("m\u00b3");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("\u03b5 =");
    textSlider3.setModel(new BoundedRealModel(1.0,6.0,12.0));
    textSlider3.setUnit("");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    textSlider4.setDescription("T3 =");
    textSlider4.setModel(new BoundedRealModel(300.0,923.0,1500.0));
    textSlider4.setUnit("K");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider4);
    
    textSlider5.setDescription("n =");
    textSlider5.setModel(new BoundedRealModel(1.0,1.2,1.4));
    textSlider5.setUnit("");
    textSlider5.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider5PropertyChange(evt);
        textSlider5PropertyChange1(evt);
      }
    });
    
    inputPanel1.add(textSlider5);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents

  private void labelView2SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_labelView2SourceChanged
    controlledLayeredScreen1.addView(labelView2);
  }//GEN-LAST:event_labelView2SourceChanged

  private void labelView1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_labelView1SourceChanged1
    controlledLayeredScreen1.addView(labelView1);
  }//GEN-LAST:event_labelView1SourceChanged1

  private void barView1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_barView1SourceChanged1
    controlledLayeredScreen1.addView(barView1);
  }//GEN-LAST:event_barView1SourceChanged1

  private void labelView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_labelView1SourceChanged
    controlledLayeredScreen1.addView(labelView1);
  }//GEN-LAST:event_labelView1SourceChanged

  private void barView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_barView1SourceChanged
    controlledLayeredScreen1.addView(barView1);
  }//GEN-LAST:event_barView1SourceChanged
  
  private void textSlider5PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange1
    double val = textSlider5.getValue();
    cyclicProcess1.changePolytropicExponent(0, val);
    cyclicProcess1.changePolytropicExponent(2, val);
  }//GEN-LAST:event_textSlider5PropertyChange1
  
  private void textSlider5PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider5PropertyChange
    arithmeticFunction1.setFourthArg(textSlider5.getValue());
  }//GEN-LAST:event_textSlider5PropertyChange
      
  private void arithmeticFunction2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction2ValueChanged
    multiplexer1.setInputValues(2, arithmeticFunction2.getResult());
  }//GEN-LAST:event_arithmeticFunction2ValueChanged
  
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    arithmeticFunction2.setFirstArg(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
  
  private void arithmeticFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_arithmeticFunction1ValueChanged
    multiplexer1.setInputValues(1, arithmeticFunction1.getResult());
  }//GEN-LAST:event_arithmeticFunction1ValueChanged
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    double val = textSlider3.getValue();
    arithmeticFunction1.setSecondArg(val);
    arithmeticFunction2.setFourthArg(val);
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void multiplexer3ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer3ValueChanged
    DVector vec = multiplexer3.getOutputVector();
    barView1.setModel(vec);
    labelView1.setValues(vec);
  }//GEN-LAST:event_multiplexer3ValueChanged
  
  private void perfectGas1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged1
    multiplexer3.setInputValues(0, perfectGas1.getInnerEnergy());
    multiplexer3.setInputValues(1, perfectGas1.getWork());
    multiplexer3.setInputValues(2, perfectGas1.getHeat());
    multiplexer3.setInputValues(3, perfectGas1.getTechnicalWork());
    multiplexer3.setInputValues(4, perfectGas1.getEnthalpy());
  }//GEN-LAST:event_perfectGas1SourceChanged1
  
  private void multiplexer2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer2ValueChanged
    xYScope1.setInputVector(multiplexer2.getOutputVector());
  }//GEN-LAST:event_multiplexer2ValueChanged
  
  private void perfectGas1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged
    multiplexer2.setInputValues(0, perfectGas1.getVolume());
    multiplexer2.setInputValues(1, perfectGas1.getPressure());
  }//GEN-LAST:event_perfectGas1SourceChanged
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    cyclicProcess1.setPoints(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    double val = textSlider2.getValue();
    multiplexer1.setInputValues(0, val);
    arithmeticFunction1.setFirstArg(val);
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    double val = textSlider1.getValue();
    cyclicProcess1.setStartPressure(val);
    arithmeticFunction2.setThirdArg(val);
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    xYScope1.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    cyclicProcess1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    cyclicProcess1.nextStep();
    multiplexer2.trigger();
  }//GEN-LAST:event_timer1NextStep
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.func.ArithmeticFunction arithmeticFunction1;
  protected physbeans.func.ArithmeticFunction arithmeticFunction2;
  protected physbeans.views.BarView barView1;
  protected physbeans.inout.ControlledLayeredScreen controlledLayeredScreen1;
  protected physbeans.phys.CyclicProcess cyclicProcess1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.views.LabelView labelView1;
  protected physbeans.views.LabelView labelView2;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.func.Multiplexer multiplexer2;
  protected physbeans.func.Multiplexer multiplexer3;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PerfectGas perfectGas1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.TextSlider textSlider5;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.XYScope xYScope1;
// End of variables declaration//GEN-END:variables
  
}
