package physapps.thermodynamics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.phys.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class IdealGasStateChange extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new IdealGasStateChange(), 560, 470);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
// <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    reversibleStateChange1 = new physbeans.phys.ReversibleStateChange();
    perfectGas1 = new physbeans.phys.PerfectGas();
    multiplexer1 = new physbeans.func.Multiplexer();
    vectorElementFunction1 = new physbeans.func.VectorElementFunction();
    multiplexer2 = new physbeans.func.Multiplexer();
    cylinderView1 = new physbeans.views.CylinderView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    numericTextField1 = new physbeans.inout.NumericTextField();
    outputPanel1 = new physbeans.inout.OutputPanel();
    xYScope1 = new physbeans.inout.XYScope();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    radioButtonBox1 = new physbeans.inout.RadioButtonBox();
    
    reversibleStateChange1.setNSteps(100);
    reversibleStateChange1.setFinalPressure(100000.0);
    reversibleStateChange1.setN(1.4);
    reversibleStateChange1.setStartPressure(1000000.0);
    reversibleStateChange1.setSystem(perfectGas1);
    perfectGas1.setMass(0.0060);
    perfectGas1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        perfectGas1SourceChanged(evt);
        perfectGas1SourceChanged1(evt);
      }
    });
    
    multiplexer1.setAutoTriggered(false);
    multiplexer1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer1ValueChanged(evt);
      }
    });
    
    vectorElementFunction1.setVector(DVector.valueOf("[0.0,Infinity,1.0,1.4]"));
    vectorElementFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        vectorElementFunction1ValueChanged(evt);
      }
    });
    
    multiplexer2.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexer2ValueChanged(evt);
      }
    });
    
    cylinderView1.setTMin(150.0);
    cylinderView1.setInitialValues(DVector.valueOf("[1.435,1000.0]"));
    cylinderView1.setMaxVolume(0.012);
    cylinderView1.setPistonDiameter(0.03);
    cylinderView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        cylinderView1SourceChanged(evt);
        cylinderView1SourceChanged1(evt);
      }
    });
    
    
    jPanel1.setLayout(new java.awt.BorderLayout());
    
    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));
    
    jPanel2.setFont(standardFont);
    layeredScreen1.setBackground(java.awt.Color.white);
    layeredScreen1.setBordered(true);
    layeredScreen1.setMaxX(1.2);
    layeredScreen1.setMaxY(0.8);
    layeredScreen1.setMinX(-0.2);
    layeredScreen1.setMinY(-0.8);
    layeredScreen1.setOpaque(true);
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);
    
    numericTextField1.setDescription("T =");
    numericTextField1.setEditable(false);
    numericTextField1.setPrecision(4);
    numericTextField1.setUnit("K");
    objectPanel1.add(numericTextField1, java.awt.BorderLayout.SOUTH);
    
    jPanel2.add(objectPanel1);
    
    xYScope1.setMaxX(0.0111);
    xYScope1.setMaxY(1500000.0);
    xYScope1.setMinX(0.0);
    xYScope1.setMinY(0.0);
    xYScope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.IdealGasStateChange", currentLocale).getString("osciPosition"));
    xYScope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.IdealGasStateChange", currentLocale).getString("osciScale"));
    outputPanel1.add(xYScope1);
    
    jPanel2.add(outputPanel1);
    
    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);
    
    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));
    
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.thermodynamics.IdealGasStateChange", currentLocale).getString("timerLabel"));
    timer1.setStopTime(10.0);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
      }
    });
    
    inputPanel1.add(timer1);
    
    textSlider1.setDescription("V0 =");
    textSlider1.setModel(new BoundedRealModel(1.0E-4,0.0010,0.011));
    textSlider1.setUnit("m\u00b3");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider1);
    
    textSlider2.setDescription("p0 =");
    textSlider2.setModel(new BoundedRealModel(10000.0,1000000.0,1100000.0));
    textSlider2.setUnit("Pa");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider2);
    
    textSlider3.setDescription("V1 =");
    textSlider3.setModel(new BoundedRealModel(1.0E-4,0.01,0.011));
    textSlider3.setUnit("m\u00b3");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    
    inputPanel1.add(textSlider3);
    
    radioButtonBox1.setBoxLabel(new String[] {
      java.util.ResourceBundle.getBundle("physapps.thermodynamics.IdealGasStateChange", currentLocale).getString("s1"),
      java.util.ResourceBundle.getBundle("physapps.thermodynamics.IdealGasStateChange", currentLocale).getString("s2"),
      java.util.ResourceBundle.getBundle("physapps.thermodynamics.IdealGasStateChange", currentLocale).getString("s3"),
      java.util.ResourceBundle.getBundle("physapps.thermodynamics.IdealGasStateChange", currentLocale).getString("s4")
    });
    radioButtonBox1.setSelected(3);
    radioButtonBox1.setTitle(java.util.ResourceBundle.getBundle("physapps.thermodynamics.IdealGasStateChange", currentLocale).getString("s5"));
    radioButtonBox1.addSwitchListener(new physbeans.event.SwitchListener() {
      public void valueChanged(physbeans.event.SwitchEvent evt) {
        radioButtonBox1ValueChanged(evt);
      }
    });
    
    inputPanel1.add(radioButtonBox1);
    
    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);
    
    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    
  }// </editor-fold>//GEN-END:initComponents

  private void cylinderView1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_cylinderView1SourceChanged1
    layeredScreen1.addView(cylinderView1);
  }//GEN-LAST:event_cylinderView1SourceChanged1

  private void cylinderView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_cylinderView1SourceChanged
    layeredScreen1.addView(cylinderView1);
  }//GEN-LAST:event_cylinderView1SourceChanged
  
  private void perfectGas1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged1
    double T = perfectGas1.getTemperature();
    multiplexer2.setInputValues(0, perfectGas1.getVolume());
    multiplexer2.setInputValues(1, T);
    numericTextField1.setValue(T);
  }//GEN-LAST:event_perfectGas1SourceChanged1
  
  private void multiplexer2ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer2ValueChanged
    cylinderView1.setModel(multiplexer2.getOutputVector());
  }//GEN-LAST:event_multiplexer2ValueChanged
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    reversibleStateChange1.setFinalVolume(textSlider3.getValue());
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    reversibleStateChange1.setStartPressure(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    reversibleStateChange1.setStartVolume(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void multiplexer1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexer1ValueChanged
    xYScope1.setInputVector(multiplexer1.getOutputVector());
  }//GEN-LAST:event_multiplexer1ValueChanged
  
  private void vectorElementFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_vectorElementFunction1ValueChanged
    reversibleStateChange1.setN(vectorElementFunction1.getOutputValue());
  }//GEN-LAST:event_vectorElementFunction1ValueChanged
  
  private void radioButtonBox1ValueChanged(physbeans.event.SwitchEvent evt) {//GEN-FIRST:event_radioButtonBox1ValueChanged
    vectorElementFunction1.setInputValue(radioButtonBox1.getSelectedAsDouble());
  }//GEN-LAST:event_radioButtonBox1ValueChanged
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    xYScope1.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    reversibleStateChange1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void perfectGas1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged
    multiplexer1.setInputValues(0, perfectGas1.getVolume());
    multiplexer1.setInputValues(1, perfectGas1.getPressure());
  }//GEN-LAST:event_perfectGas1SourceChanged
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    reversibleStateChange1.nextStep();
    multiplexer1.trigger();
  }//GEN-LAST:event_timer1NextStep
  
  
// Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.CylinderView cylinderView1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.Multiplexer multiplexer1;
  protected physbeans.func.Multiplexer multiplexer2;
  protected physbeans.inout.NumericTextField numericTextField1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.PerfectGas perfectGas1;
  protected physbeans.inout.RadioButtonBox radioButtonBox1;
  protected physbeans.phys.ReversibleStateChange reversibleStateChange1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.Timer timer1;
  protected physbeans.func.VectorElementFunction vectorElementFunction1;
  protected physbeans.inout.XYScope xYScope1;
// End of variables declaration//GEN-END:variables
  
}
