package physapps.thermodynamics;

import javax.swing.*;
import java.awt.*;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.phys.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class PathDependency extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new PathDependency(), 655, 470);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents() {
    multiplexerParserInput = new physbeans.func.Multiplexer();
    parsedFunctionNs = new physbeans.func.ParsedFunction();
    parsedFunctionSwitch = new physbeans.func.ParsedFunction();
    multiplexerPs = new physbeans.func.Multiplexer();
    multiplexerVs = new physbeans.func.Multiplexer();
    mergeFunction1 = new physbeans.func.MergeFunction();
    cyclicProcess1 = new physbeans.phys.CyclicProcess();
    perfectGas1 = new physbeans.phys.PerfectGas();
    muxScope = new physbeans.func.Multiplexer();
    muxCylinderView = new physbeans.func.Multiplexer();
    cylinderView1 = new physbeans.views.CylinderView();
    multiplexerEnergies = new physbeans.func.Multiplexer();
    barView1 = new physbeans.views.BarView();
    labelView1 = new physbeans.views.LabelView();
    labelView2 = new physbeans.views.LabelView();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel = new physbeans.inout.PhysicsPanel();
    physicsPanel1 = new physbeans.inout.PhysicsPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    numericTextField1 = new physbeans.inout.NumericTextField();
    controlledLayeredScreen1 = new physbeans.inout.ControlledLayeredScreen();
    outputPanel = new physbeans.inout.PhysicsPanel();
    xYScope1 = new physbeans.inout.XYScope();
    inputPanel = new physbeans.inout.PhysicsPanel();
    timer1 = new physbeans.inout.Timer();
    textSliderP1 = new physbeans.inout.TextSlider();
    textSliderV1 = new physbeans.inout.TextSlider();
    textSliderP2 = new physbeans.inout.TextSlider();
    textSliderV2 = new physbeans.inout.TextSlider();
    textSliderP3 = new physbeans.inout.TextSlider();
    textSliderV3 = new physbeans.inout.TextSlider();

    multiplexerParserInput.setCollectInput(false);
    multiplexerParserInput.setInputLength(6);
    multiplexerParserInput.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexerParserInputValueChanged(evt);
      }
    });

    parsedFunctionNs.setFunction(new String[] {"if(abs(n1) < 80,n1,infinity);n1:(log(p1)-log(p2))/(log(V2)-log(V1))", "if(abs(n2)<80,n2,infinity);n2:(log(p2)-log(p3))/(log(V3)-log(V2))", "0", "infinity"});
    parsedFunctionNs.setVariableName(new String[] {"p1", "V1", "p2", "V2", "p3", "V3"});
    parsedFunctionNs.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedFunctionNsValueChanged(evt);
        parsedFunctionNsValueChanged1(evt);
      }
    });

    parsedFunctionSwitch.setFunction(new String[] {"0", "if(n1=infinity,1,0)", "if(n2=infinity,1,0)"});
    parsedFunctionSwitch.setVariableName(new String[] {"n1", "n2", "n3"});
    parsedFunctionSwitch.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        parsedFunctionSwitchValueChanged(evt);
      }
    });

    multiplexerPs.setCollectInput(false);
    multiplexerPs.setInputLength(3);
    multiplexerPs.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexerPsValueChanged(evt);
      }
    });

    multiplexerVs.setCollectInput(false);
    multiplexerVs.setInputLength(3);
    multiplexerVs.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexerVsValueChanged(evt);
      }
    });

    mergeFunction1.setCombineMode(false);
    mergeFunction1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        mergeFunction1ValueChanged(evt);
      }
    });

    cyclicProcess1.setNSteps(new int[]{80,80,5,5});
    cyclicProcess1.setPoints(DVector.valueOf("[0.0,0.0,0.0]"));
    cyclicProcess1.setPolytropicExponents(DVector.valueOf("[0.0,0.0,0.0,0.0]"));
    cyclicProcess1.setSystem(perfectGas1);
    perfectGas1.setAutoReset(false);
    perfectGas1.setMass(0.0050);
    perfectGas1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        perfectGas1SourceChanged(evt);
        perfectGas1SourceChanged1(evt);
        perfectGas1SourceChanged2(evt);
      }
    });

    muxScope.setAutoTriggered(false);
    muxScope.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        muxScopeValueChanged(evt);
      }
    });

    muxCylinderView.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        muxCylinderViewValueChanged(evt);
      }
    });

    cylinderView1.setTMax(1500.0);
    cylinderView1.setTMin(300.0);
    cylinderView1.setMaxVolume(0.0025);
    cylinderView1.setPistonDiameter(0.03);
    cylinderView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        cylinderView1SourceChanged(evt);
      }
    });

    multiplexerEnergies.setInputLength(5);
    multiplexerEnergies.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        multiplexerEnergiesValueChanged(evt);
      }
    });

    barView1.setBarWidth(0.8);
    barView1.setEqualBarColor(false);
    barView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        barView1SourceChanged(evt);
      }
    });

    labelView1.setDepth(40);
    labelView1.setMarginLeft(0.0);
    labelView1.setMarginRight(0.0);
    labelView1.setPrecision(3);
    labelView2.setDepth(30);
    labelView2.setInitialValues(new String[] {"U", "Wv", "Q", "Wt", "H"});
    labelView2.setMarginLeft(0.0);
    labelView2.setMarginRight(0.0);
    labelView2.setPosition(1.0);

    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

    jPanel2.setFont(standardFont);
    objectPanel.setLayout(new javax.swing.BoxLayout(objectPanel, javax.swing.BoxLayout.X_AXIS));

    objectPanel.setBackground(new java.awt.Color(255, 255, 175));
    objectPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
    objectPanel.setFont(standardFont);
    objectPanel.setOpaque(true);
    physicsPanel1.setLayout(new java.awt.BorderLayout());

    physicsPanel1.setBordered(true);
    physicsPanel1.setPreferredSize(new java.awt.Dimension(200, 100));
    layeredScreen1.setBackground(java.awt.Color.white);
    layeredScreen1.setBordered(true);
    layeredScreen1.setMaxX(1.2);
    layeredScreen1.setMaxY(0.8);
    layeredScreen1.setMinX(-0.2);
    layeredScreen1.setMinY(-0.8);
    layeredScreen1.setOpaque(true);
    physicsPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    numericTextField1.setDescription("T =");
    numericTextField1.setEditable(false);
    numericTextField1.setPrecision(4);
    numericTextField1.setUnit("K");
    physicsPanel1.add(numericTextField1, java.awt.BorderLayout.SOUTH);

    objectPanel.add(physicsPanel1);

    controlledLayeredScreen1.setBordered(true);
    controlledLayeredScreen1.setMaxX(4.9);
    controlledLayeredScreen1.setMaxY(8000.0);
    controlledLayeredScreen1.setMinX(-0.1);
    controlledLayeredScreen1.setMinY(-4000.0);
    controlledLayeredScreen1.setPositionLabel("");
    controlledLayeredScreen1.setScaleLabel("");
    controlledLayeredScreen1.setViewActive(new boolean[]{true,true,true});
    objectPanel.add(controlledLayeredScreen1);

    jPanel2.add(objectPanel);

    outputPanel.setLayout(new javax.swing.BoxLayout(outputPanel, javax.swing.BoxLayout.X_AXIS));

    outputPanel.setBackground(new java.awt.Color(150, 200, 255));
    outputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    outputPanel.setFont(standardFont);
    outputPanel.setOpaque(true);
    xYScope1.setBufferSize(5000);
    xYScope1.setDotSize(6);
    xYScope1.setMaxX(0.00255);
    xYScope1.setMaxY(7000000.0);
    xYScope1.setMinX(0.0);
    xYScope1.setMinY(0.0);
    xYScope1.setPositionLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.PathDependency", currentLocale).getString("osciPosition"));
    xYScope1.setScaleLabel(java.util.ResourceBundle.getBundle("physapps.thermodynamics.PathDependency", currentLocale).getString("osciScale"));
    xYScope1.setShowMarker(true);
    outputPanel.add(xYScope1);

    jPanel2.add(outputPanel);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel.setLayout(new javax.swing.BoxLayout(inputPanel, javax.swing.BoxLayout.Y_AXIS));

    inputPanel.setBackground(new java.awt.Color(100, 255, 255));
    inputPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    inputPanel.setFont(standardFont);
    inputPanel.setOpaque(true);
    timer1.setDelay(30L);
    timer1.setExplanation(java.util.ResourceBundle.getBundle("physapps.thermodynamics.PathDependency", currentLocale).getString("timerLabel"));
    timer1.setStopTime(16.2);
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
        timer1Restart1(evt);
      }
    });

    inputPanel.add(timer1);

    textSliderP1.setDescription("p1 =");
    textSliderP1.setModel(new BoundedRealModel(10000.0,300000.0,6000000.0));
    textSliderP1.setUnit("Pa");
    textSliderP1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderP1PropertyChange(evt);
        textSliderP1PropertyChange1(evt);
      }
    });

    inputPanel.add(textSliderP1);

    textSliderV1.setDescription("V1 =");
    textSliderV1.setModel(new BoundedRealModel(2.0E-4,0.0020,0.0025));
    textSliderV1.setUnit("m\u00b3");
    textSliderV1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderV1PropertyChange(evt);
      }
    });

    inputPanel.add(textSliderV1);

    textSliderP2.setDescription("p2 =");
    textSliderP2.setModel(new BoundedRealModel(10000.0,2500000.0,6000000.0));
    textSliderP2.setUnit("Pa");
    textSliderP2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderP2PropertyChange(evt);
      }
    });

    inputPanel.add(textSliderP2);

    textSliderV2.setDescription("V2 =");
    textSliderV2.setModel(new BoundedRealModel(2.0E-4,0.0010,0.0025));
    textSliderV2.setUnit("m\u00b3");
    textSliderV2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderV2PropertyChange(evt);
      }
    });

    inputPanel.add(textSliderV2);

    textSliderP3.setDescription("p3 =");
    textSliderP3.setModel(new BoundedRealModel(10000.0,5000000.0,6000000.0));
    textSliderP3.setUnit("Pa");
    textSliderP3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderP3PropertyChange(evt);
      }
    });

    inputPanel.add(textSliderP3);

    textSliderV3.setDescription("V3 =");
    textSliderV3.setModel(new BoundedRealModel(2.0E-4,2.5E-4,0.0025));
    textSliderV3.setUnit("m\u00b3");
    textSliderV3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSliderV3PropertyChange(evt);
      }
    });

    inputPanel.add(textSliderV3);

    jPanel1.add(inputPanel, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

  }// </editor-fold>//GEN-END:initComponents
  
  private void multiplexerEnergiesValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexerEnergiesValueChanged
    DVector vec = multiplexerEnergies.getOutputVector();
    barView1.setModel(vec);
    labelView1.setValues(vec);
  }//GEN-LAST:event_multiplexerEnergiesValueChanged
  
  private void barView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_barView1SourceChanged
    controlledLayeredScreen1.addView(barView1);
    controlledLayeredScreen1.addView(labelView1);
    controlledLayeredScreen1.addView(labelView2);
  }//GEN-LAST:event_barView1SourceChanged
  
  private void parsedFunctionSwitchValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedFunctionSwitchValueChanged
    mergeFunction1.setUseFirstVectorFromDVector(parsedFunctionSwitch.getOutputVector());
  }//GEN-LAST:event_parsedFunctionSwitchValueChanged
  
  private void parsedFunctionNsValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedFunctionNsValueChanged1
    parsedFunctionSwitch.setInputVector(parsedFunctionNs.getOutputVector());
  }//GEN-LAST:event_parsedFunctionNsValueChanged1
  
  private void mergeFunction1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_mergeFunction1ValueChanged
    cyclicProcess1.setPoints(mergeFunction1.getOutputVector());
  }//GEN-LAST:event_mergeFunction1ValueChanged
  
  private void multiplexerVsValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexerVsValueChanged
    mergeFunction1.setSecondVector(multiplexerVs.getOutputVector());
  }//GEN-LAST:event_multiplexerVsValueChanged
  
  private void multiplexerPsValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexerPsValueChanged
    mergeFunction1.setFirstVector(multiplexerPs.getOutputVector());
  }//GEN-LAST:event_multiplexerPsValueChanged
  
  private void textSliderP1PropertyChange1(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderP1PropertyChange1
    multiplexerParserInput.singleInputValue(0, textSliderP1.getValue());
    multiplexerPs.singleInputValue(0, textSliderP1.getValue());
  }//GEN-LAST:event_textSliderP1PropertyChange1
  
  private void parsedFunctionNsValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_parsedFunctionNsValueChanged
    cyclicProcess1.setPolytropicExponents(parsedFunctionNs.getOutputVector());
  }//GEN-LAST:event_parsedFunctionNsValueChanged
  
  private void multiplexerParserInputValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_multiplexerParserInputValueChanged
    parsedFunctionNs.setInputVector(multiplexerParserInput.getOutputVector());
  }//GEN-LAST:event_multiplexerParserInputValueChanged
  
  private void textSliderV3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderV3PropertyChange
    multiplexerParserInput.singleInputValue(5, textSliderV3.getValue());
    multiplexerVs.singleInputValue(2, textSliderV3.getValue());
  }//GEN-LAST:event_textSliderV3PropertyChange
  
  private void textSliderV2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderV2PropertyChange
    multiplexerParserInput.singleInputValue(3, textSliderV2.getValue());
    multiplexerVs.singleInputValue(1, textSliderV2.getValue());
  }//GEN-LAST:event_textSliderV2PropertyChange
  
  private void textSliderP3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderP3PropertyChange
    multiplexerParserInput.singleInputValue(4, textSliderP3.getValue());
    multiplexerPs.singleInputValue(2, textSliderP3.getValue());
  }//GEN-LAST:event_textSliderP3PropertyChange
  
  private void textSliderP2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderP2PropertyChange
    multiplexerParserInput.singleInputValue(2, textSliderP2.getValue());
    multiplexerPs.singleInputValue(1, textSliderP2.getValue());
  }//GEN-LAST:event_textSliderP2PropertyChange
  
  private void cylinderView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_cylinderView1SourceChanged
    layeredScreen1.addView(cylinderView1);
  }//GEN-LAST:event_cylinderView1SourceChanged
  
  private void muxCylinderViewValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_muxCylinderViewValueChanged
    cylinderView1.setModel(muxCylinderView.getOutputVector());
  }//GEN-LAST:event_muxCylinderViewValueChanged
  
  private void perfectGas1SourceChanged2(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged2
    numericTextField1.setValue(perfectGas1.getTemperature());
  }//GEN-LAST:event_perfectGas1SourceChanged2
  
  private void perfectGas1SourceChanged1(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged1
    muxCylinderView.setInputValues(0, perfectGas1.getVolume());
    muxCylinderView.setInputValues(1, perfectGas1.getTemperature());
  }//GEN-LAST:event_perfectGas1SourceChanged1
  
  private void muxScopeValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_muxScopeValueChanged
    xYScope1.setInputVector(muxScope.getOutputVector());
  }//GEN-LAST:event_muxScopeValueChanged
  
  private void perfectGas1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_perfectGas1SourceChanged
    muxScope.setInputValues(0, perfectGas1.getVolume());
    muxScope.setInputValues(1, perfectGas1.getPressure());
    multiplexerEnergies.setInputValues(0, perfectGas1.getInnerEnergy());
    multiplexerEnergies.setInputValues(1, perfectGas1.getWork());
    multiplexerEnergies.setInputValues(2, perfectGas1.getHeat());
    multiplexerEnergies.setInputValues(3, perfectGas1.getTechnicalWork());
    multiplexerEnergies.setInputValues(4, perfectGas1.getEnthalpy());
  }//GEN-LAST:event_perfectGas1SourceChanged
  
  private void textSliderV1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderV1PropertyChange
    multiplexerParserInput.setInputValues(1, textSliderV1.getValue());
    multiplexerVs.singleInputValue(0, textSliderV1.getValue());
  }//GEN-LAST:event_textSliderV1PropertyChange
  
  private void textSliderP1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSliderP1PropertyChange
    cyclicProcess1.setStartPressure(textSliderP1.getValue());
  }//GEN-LAST:event_textSliderP1PropertyChange
  
  private void timer1Restart1(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart1
    xYScope1.restart();
  }//GEN-LAST:event_timer1Restart1
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    cyclicProcess1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    cyclicProcess1.nextStep();
    muxScope.trigger();
  }//GEN-LAST:event_timer1NextStep
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.BarView barView1;
  protected physbeans.inout.ControlledLayeredScreen controlledLayeredScreen1;
  protected physbeans.phys.CyclicProcess cyclicProcess1;
  protected physbeans.views.CylinderView cylinderView1;
  protected physbeans.inout.PhysicsPanel inputPanel;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.views.LabelView labelView1;
  protected physbeans.views.LabelView labelView2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.func.MergeFunction mergeFunction1;
  protected physbeans.func.Multiplexer multiplexerEnergies;
  protected physbeans.func.Multiplexer multiplexerParserInput;
  protected physbeans.func.Multiplexer multiplexerPs;
  protected physbeans.func.Multiplexer multiplexerVs;
  protected physbeans.func.Multiplexer muxCylinderView;
  protected physbeans.func.Multiplexer muxScope;
  protected physbeans.inout.NumericTextField numericTextField1;
  protected physbeans.inout.PhysicsPanel objectPanel;
  protected physbeans.inout.PhysicsPanel outputPanel;
  protected physbeans.func.ParsedFunction parsedFunctionNs;
  protected physbeans.func.ParsedFunction parsedFunctionSwitch;
  protected physbeans.phys.PerfectGas perfectGas1;
  protected physbeans.inout.PhysicsPanel physicsPanel1;
  protected physbeans.inout.TextSlider textSliderP1;
  protected physbeans.inout.TextSlider textSliderP2;
  protected physbeans.inout.TextSlider textSliderP3;
  protected physbeans.inout.TextSlider textSliderV1;
  protected physbeans.inout.TextSlider textSliderV2;
  protected physbeans.inout.TextSlider textSliderV3;
  protected physbeans.inout.Timer timer1;
  protected physbeans.inout.XYScope xYScope1;
  // End of variables declaration//GEN-END:variables
  
}
