package physapps.waves;
import physbeans.inout.*;
import physbeans.model.*;
import physbeans.math.*;

/**
 * template for simulation applets<br>
 * contains an input, object and output panel
 */
public class Refraction extends PhysBeansApplet {
  
  static public void main(String[] args) {
    startApp(new Refraction(), 560, 500);
  }
  
  /** Creates new form Simulation */
  public void init() {
    setLocale();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    rippleTank1 = new physbeans.phys.RippleTank();
    gridView1 = new physbeans.views.GridView();
    lineWaveSource1 = new physbeans.phys.LineWaveSource();
    halfSpaceWaveMedium1 = new physbeans.phys.HalfSpaceWaveMedium();
    gridView2 = new physbeans.views.GridView();
    transparentColorTable1 = new physbeans.views.TransparentColorTable();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    objectPanel1 = new physbeans.inout.ObjectPanel();
    layeredScreen1 = new physbeans.inout.LayeredScreen();
    outputPanel1 = new physbeans.inout.OutputPanel();
    vectorTextField1 = new physbeans.inout.VectorTextField();
    numericTextField1 = new physbeans.inout.NumericTextField();
    inputPanel1 = new physbeans.inout.InputPanel();
    timer1 = new physbeans.inout.Timer();
    textSlider1 = new physbeans.inout.TextSlider();
    textSlider2 = new physbeans.inout.TextSlider();
    textSlider3 = new physbeans.inout.TextSlider();
    textSlider4 = new physbeans.inout.TextSlider();

    rippleTank1.setYMax(1.2727);
    rippleTank1.setYMin(-1.2727);
    rippleTank1.setMedium(halfSpaceWaveMedium1);
    rippleTank1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        rippleTank1SourceChanged(evt);
      }
    });
    rippleTank1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        rippleTank1ValueChanged(evt);
      }
    });

    gridView1.setDepth(60);
    gridView1.setInfiniteScale(true);
    gridView1.setMaxVal(0.3);
    gridView1.setMinVal(-0.3);
    gridView1.setScale(0.5);
    gridView1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        gridView1SourceChanged(evt);
      }
    });

    lineWaveSource1.setPhase(0.8);
    lineWaveSource1.setPosition1(DVector.valueOf("[-0.7768,-0.4232]"));
    lineWaveSource1.setPosition2(DVector.valueOf("[-0.4232,-0.7768]"));
    lineWaveSource1.setPulseWave(true);
    lineWaveSource1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        lineWaveSource1SourceChanged(evt);
      }
    });

    halfSpaceWaveMedium1.addTriggerListener(new physbeans.event.TriggerListener() {
      public void sourceChanged(physbeans.event.TriggerEvent evt) {
        halfSpaceWaveMedium1SourceChanged(evt);
      }
    });

    gridView2.setColors(transparentColorTable1);

    transparentColorTable1.setColor(new java.awt.Color(0, 247, 1));
    transparentColorTable1.setInverse(true);

    jPanel1.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED)));
    jPanel1.setFont(standardFont);
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel2.setFont(standardFont);
    jPanel2.setPreferredSize(new java.awt.Dimension(290, 300));
    jPanel2.setLayout(new java.awt.BorderLayout());

    objectPanel1.setPreferredSize(new java.awt.Dimension(106, 300));

    layeredScreen1.setEqualScales(true);
    layeredScreen1.addVectorListener(new physbeans.event.VectorListener() {
      public void valueChanged(physbeans.event.VectorEvent evt) {
        layeredScreen1ValueChanged(evt);
        layeredScreen1ValueChanged1(evt);
      }
    });
    objectPanel1.add(layeredScreen1, java.awt.BorderLayout.CENTER);

    jPanel2.add(objectPanel1, java.awt.BorderLayout.CENTER);

    outputPanel1.setLayout(new javax.swing.BoxLayout(outputPanel1, javax.swing.BoxLayout.Y_AXIS));

    vectorTextField1.setBordered(true);
    vectorTextField1.setHorizontal(true);
    outputPanel1.add(vectorTextField1);

    numericTextField1.setBordered(true);
    java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("physapps.waves.Refraction", currentLocale); // NOI18N
    numericTextField1.setDescription(bundle.getString("s1")); // NOI18N
    numericTextField1.setEditable(false);
    numericTextField1.setUnit("");
    outputPanel1.add(numericTextField1);

    jPanel2.add(outputPanel1, java.awt.BorderLayout.SOUTH);

    jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

    inputPanel1.setLayout(new javax.swing.BoxLayout(inputPanel1, javax.swing.BoxLayout.Y_AXIS));

    timer1.setExplanation(bundle.getString("timerLabel")); // NOI18N
    timer1.addTimerListener(new physbeans.event.TimerListener() {
      public void nextStep(physbeans.event.NextStepEvent evt) {
        timer1NextStep(evt);
      }
      public void restart(physbeans.event.RestartEvent evt) {
        timer1Restart(evt);
      }
    });
    inputPanel1.add(timer1);

    textSlider1.setDescription("f =");
    textSlider1.setModel(new BoundedRealModel(1.0,5.0,10.0));
    textSlider1.setUnit("Hz");
    textSlider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider1PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider1);

    textSlider2.setDescription("A = ");
    textSlider2.setModel(new BoundedRealModel(0.0,1.0,3.0));
    textSlider2.setUnit("m");
    textSlider2.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider2PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider2);

    textSlider3.setDescription("\u03b1 =");
    textSlider3.setModel(new BoundedRealModel(0.0,0.25,0.5));
    textSlider3.setUnit("* \u03c0");
    textSlider3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider3PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider3);

    textSlider4.setDescription("c2 =");
    textSlider4.setModel(new BoundedRealModel(0.5,0.7,1.0));
    textSlider4.setUnit("m/s");
    textSlider4.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        textSlider4PropertyChange(evt);
      }
    });
    inputPanel1.add(textSlider4);

    jPanel1.add(inputPanel1, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
  }// </editor-fold>//GEN-END:initComponents

  private void rippleTank1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_rippleTank1ValueChanged
    numericTextField1.setValue(rippleTank1.getLastScalarValue());
  }//GEN-LAST:event_rippleTank1ValueChanged

  private void lineWaveSource1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_lineWaveSource1SourceChanged
    rippleTank1.addSource(lineWaveSource1);
  }//GEN-LAST:event_lineWaveSource1SourceChanged
  
  private void gridView1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_gridView1SourceChanged
    layeredScreen1.addView(gridView1);
    layeredScreen1.addView(gridView2);
  }//GEN-LAST:event_gridView1SourceChanged
    
  private void textSlider4PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider4PropertyChange
    halfSpaceWaveMedium1.setUpperVelocity(textSlider4.getValue());
  }//GEN-LAST:event_textSlider4PropertyChange
    
  private void layeredScreen1ValueChanged1(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged1
    rippleTank1.sendScalarValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged1
  
  private void layeredScreen1ValueChanged(physbeans.event.VectorEvent evt) {//GEN-FIRST:event_layeredScreen1ValueChanged
    vectorTextField1.setValue(layeredScreen1.getClickedPosition());
  }//GEN-LAST:event_layeredScreen1ValueChanged
  
  private void textSlider3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider3PropertyChange
    lineWaveSource1.setAngle(Math.PI*(0.5 + textSlider3.getValue()));
  }//GEN-LAST:event_textSlider3PropertyChange
  
  private void textSlider2PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider2PropertyChange
    lineWaveSource1.setAmplitude(textSlider2.getValue());
  }//GEN-LAST:event_textSlider2PropertyChange
  
  private void textSlider1PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_textSlider1PropertyChange
    lineWaveSource1.setFrequency(textSlider1.getValue());
  }//GEN-LAST:event_textSlider1PropertyChange
  
  private void timer1Restart(physbeans.event.RestartEvent evt) {//GEN-FIRST:event_timer1Restart
    rippleTank1.restart();
  }//GEN-LAST:event_timer1Restart
  
  private void timer1NextStep(physbeans.event.NextStepEvent evt) {//GEN-FIRST:event_timer1NextStep
    rippleTank1.nextStep();
  }//GEN-LAST:event_timer1NextStep

  private void rippleTank1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_rippleTank1SourceChanged
    gridView1.setModel(rippleTank1);
  }//GEN-LAST:event_rippleTank1SourceChanged

  private void halfSpaceWaveMedium1SourceChanged(physbeans.event.TriggerEvent evt) {//GEN-FIRST:event_halfSpaceWaveMedium1SourceChanged
    gridView2.setModel(halfSpaceWaveMedium1);
  }//GEN-LAST:event_halfSpaceWaveMedium1SourceChanged
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected physbeans.views.GridView gridView1;
  protected physbeans.views.GridView gridView2;
  protected physbeans.phys.HalfSpaceWaveMedium halfSpaceWaveMedium1;
  protected physbeans.inout.InputPanel inputPanel1;
  protected javax.swing.JPanel jPanel1;
  protected javax.swing.JPanel jPanel2;
  protected physbeans.inout.LayeredScreen layeredScreen1;
  protected physbeans.phys.LineWaveSource lineWaveSource1;
  protected physbeans.inout.NumericTextField numericTextField1;
  protected physbeans.inout.ObjectPanel objectPanel1;
  protected physbeans.inout.OutputPanel outputPanel1;
  protected physbeans.phys.RippleTank rippleTank1;
  protected physbeans.inout.TextSlider textSlider1;
  protected physbeans.inout.TextSlider textSlider2;
  protected physbeans.inout.TextSlider textSlider3;
  protected physbeans.inout.TextSlider textSlider4;
  protected physbeans.inout.Timer timer1;
  protected physbeans.views.TransparentColorTable transparentColorTable1;
  protected physbeans.inout.VectorTextField vectorTextField1;
  // End of variables declaration//GEN-END:variables
  
}
